local mod_storage_load, mod_storage_save = mod_storage_load, mod_storage_save

timeStopped = 0
timeStopFailSafe = 0
timeStopCooldown = 3

introTimer = 0
gMmxStates = {}
enable_sounds = true
for i = 0, (MAX_PLAYERS - 1) do
    gMmxStates[i] = {}
    local mmx = gMmxStates[i]
    local s = gPlayerSyncTable[i]
    local m = gMarioStates[i]

    -- MISC
    mmx.can_restore_glevelvalue = 1

    -- Char/Moveset enabled
    s.character = 'none'
    s.enable_voice = true
    s.enable_model = true
    s.enable_color = true
    s.menu_open = false
    s.palette_reset_signal = false

    -- Smooth continuity related
    mmx.prevPos = {x = 0, y = 0, z = 0}
    mmx.dPrevPos = {x = 0, y = 0, z = 0}
    mmx.prevFaceAngleYaw = 0
    mmx.dPrevFaceAngleYaw = 0

    -- Landing related
    mmx.land_timer = 0

    -- Grab related
    mmx.b_pressed = 0

    -- Wallkick related variables
    mmx.lastWallKickPos = {x = 0, z = 0} -- Y is not needed
    mmx.previousWallYaw = 0
    mmx.last_max_vel_wallkick = 0

    mmx.wall_prev = ''
    mmx.wall_prev_vtx1 = { x = 0, y = 0, z = 0 }
    mmx.wall_prev_normal = { x = 0, y = 0, z = 0 }
    mmx.wall_d_pos = -1
    mmx.wall_d_angle = 0
    mmx.wall_next = nil

    -- There is a chance of softlock while shocked or being pushed around by bullies
    mmx.softlock_counter = 0
    s.almostSameSideWallKicks = 0
    s.just_walljumped = 0
    s.initialFaceAngleAfterWallKick = 0
    s.firstWallKick = true

    -- Vanilla actions
    mmx.execute_groundpound = false
    mmx.execute_punch = false
    s.execute_walking = false

    -- active hitboxes
    mmx.active_hitboxes = {}
    s.mmx_hit_stop = 0

    -- X related variables
    s.x_armor = 0
    s.x_is_alia = 0
    s.x_cm = 0
    s.x_active_shots = 0
    s.x_shooting = 0
    s.x_glow_index = 0
    s.x_charge_level = 0
    s.x_charge_timer = 0
    s.x_charge_spawned = 0
    s.x_max_charge_looped = 0
    s.x_doubleshot = 0
    s.x_shoot_wait = 0
    s.x_gaea_meter = 16
    s.x_execute_double_shot = 0
    s.x_cm_in_mirror_room = false
    mmx.x_gigaarmor_holding = 0
    mmx.x_charge_sound_stopped = true
    mmx.x_right_hand_shot = false
    mmx.x_shoot_duration = 15
    mmx.x_scarf_prev = {xRotation = 0, zRotation = 0, rotBeforeLand = 0, scale = 1, waveRot = 0, waveRotDirection = 1}

    -- Zero related variables
    s.zero_alt = 0
    s.zero_double_jump = 0
    s.zero_has_handle = 1
    mmx.zero_wall_slide_slash = 0
    mmx.zero_cancel_slash = 0
    mmx.zero_raikousen_start_pos = {x = 0, y = 0, z = 0}
    mmx.zero_ledge_shippuga = 0
    s.zero_dropped_from_wall = 0
    mmx.zero_prev_anim_is_run = 0

    -- Vile related variables
    s.vile_shooting = 0
    s.vile_meter = 10

    -- Characters with dashes (Vile's dash attack doesn't count)
    s.ground_dash_cooldown = 0
    s.jump_dash_state = false
    s.already_airdashed = false
    s.jumped_from_ground_dash = false
end

if not _G.charSelectExists then
    djui_popup_create("Press D-PAD UP or write /mmx to open the \\#5B83B5\\Mega Man \\#EFC600\\X \\#ffffff\\menu.", 4)
end

function initStorage()
    local s0 = gPlayerSyncTable[gMarioStates[0].playerIndex]
    if (mod_storage_load('MmxChar')) then
        s0.character = mod_storage_load('MmxChar')
    else
        s0.character = 'x' -- Possible values: x, vile, none
        mod_storage_save('MmxChar', 'x')
    end
    if (mod_storage_load('MmxColor')) then
        if mod_storage_load('MmxColor') == 'true' then
            s0.enable_color = true
        else
            s0.enable_color = false
        end
    else
        s0.enable_color = true -- Possible values: x, vile, none
        mod_storage_save('MmxColor', 'true')
    end
    if (mod_storage_load('MmxArmor')) then
        s0.x_armor = tonumber(mod_storage_load('MmxArmor'))
    else
        s0.x_armor = 0 -- 0: No armor, 1: First Armor
        mod_storage_save('MmxArmor', '0')
    end
end

--initStorage()

function active_player(m)
    local np = gNetworkPlayers[m.playerIndex]
    if m.playerIndex == 0 then
        return true
    end
    if not np.connected then
        return false
    end
    if np.currCourseNum ~= gNetworkPlayers[0].currCourseNum then
        return false
    end
    if np.currActNum ~= gNetworkPlayers[0].currActNum then
        return false
    end
    if np.currLevelNum ~= gNetworkPlayers[0].currLevelNum then
        return false
    end
    if np.currAreaIndex ~= gNetworkPlayers[0].currAreaIndex then
        return false
    end
    return is_player_active(m)
end

function mmx_play_sound(sound, mPos, intensity)
    if enable_sounds then
        audio_sample_play(sound, mPos, intensity)
    end
end

hook_event(HOOK_ON_PLAYER_CONNECTED, function(m)
    local s =  gPlayerSyncTable[m.playerIndex]
    -- sync those again just in case
    s.character = 'none'
    s.enable_voice = true
    s.enable_model = true
    s.enable_color = true
    s.menu_open = false
    s.palette_reset_signal = false
end)