function obj_has_parent_bhv(o, bhv)
    local parentObj = o.parentObj
    if parentObj ~= nil and get_id_from_behavior(parentObj.behavior) == bhv and parentObj.activeFlags ~= 0 then
        return true
    end
    return false
end

function move_object_to_limb(o, limb, up, side, front)
    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]
    local mmx = gMmxStates[m.playerIndex]

    local yawSin = sins(m.marioObj.header.gfx.angle.y)
    local yawSideSin = sins(m.marioObj.header.gfx.angle.y - 0x4000)

    local yawCos = coss(m.marioObj.header.gfx.angle.y)
    local yawSideCos = coss(m.marioObj.header.gfx.angle.y - 0x4000)

    local pitchSin = sins(m.marioObj.header.gfx.angle.x)
    local pitchCos = coss(m.marioObj.header.gfx.angle.x)

    o.oPosX = get_hand_foot_pos_x(m, limb) + side * yawSideSin + front * yawSin * pitchCos + mmx.dPrevPos.x
    o.oPosY = get_hand_foot_pos_y(m, limb) + up + front * pitchSin + mmx.dPrevPos.y
    o.oPosZ = get_hand_foot_pos_z(m, limb) + side * yawSideCos + front * yawCos * pitchCos + mmx.dPrevPos.z

    if m.marioBodyState.updateTorsoTime ~= gMarioStates[0].marioBodyState.updateTorsoTime then
        o.oPosX = m.pos.x
        o.oPosY = m.pos.y
        o.oPosZ = m.pos.z
    end

    o.header.gfx.pos.x = o.oPosX
    o.header.gfx.pos.y = o.oPosY
    o.header.gfx.pos.z = o.oPosZ
end

function move_hitboxpos_to_limb(o, limb, up, side, front)
    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]
    local mmx = gMmxStates[m.playerIndex]

    local yawSin = sins(m.marioObj.header.gfx.angle.y)
    local yawSideSin = sins(m.marioObj.header.gfx.angle.y - 0x4000)

    local yawCos = coss(m.marioObj.header.gfx.angle.y)
    local yawSideCos = coss(m.marioObj.header.gfx.angle.y - 0x4000)

    local pitchSin = sins(m.marioObj.header.gfx.angle.x)
    local pitchCos = coss(m.marioObj.header.gfx.angle.x)

    o.oHitboxPosX = get_hand_foot_pos_x(m, limb) + side * yawSideSin + front * yawSin * pitchCos + mmx.dPrevPos.x
    o.oHitboxPosY = get_hand_foot_pos_y(m, limb) + up + front * pitchSin + mmx.dPrevPos.y
    o.oHitboxPosZ = get_hand_foot_pos_z(m, limb) + side * yawSideCos + front * yawCos * pitchCos + mmx.dPrevPos.z
end