function bhv_custom_bowser_loop(obj)
    -- make goombas leap instead of just jump
    if obj.oAction == 4 and obj.oMmxHealth <= 0 then
        obj.oForwardVel = 0
    end
end

-- hook the behavior
--id_bhvCustomBowser = hook_behavior(id_bhvBowser, get_object_list_from_behavior(get_behavior_from_id(id_bhvBowser)), false, nil, bhv_custom_bowser_loop)

healthtable = {
    -- BOB
    [id_bhvGoomba] = 1.5, 
    [id_bhvKoopa] = 1.5,
    [id_bhvBobomb] = 1.5,
    [id_bhvChainChomp] = 50,
    [id_bhvChainChompGate] = 50,
    [id_bhvWaterBomb] = 2,
    [id_bhvKingBobomb] = 40,
    [id_bhvBreakableBox] = 7,
    [id_bhvBreakableBoxSmall] = 3,
    [id_bhvTowerDoor] = 3,
    [id_bhvExclamationBox] = 2,
    [id_bhvBowlingBall] = 8,
    [id_bhvPitBowlingBall] = 8,
    [id_bhvFreeBowlingBall] = 8,
    -- WF
    [id_bhvKickableBoard] = 10,
    [id_bhvWfBreakableWallLeft] = 25,
    [id_bhvWfBreakableWallRight] = 25,
    [id_bhvSmallWhomp] = 7,
    [id_bhvWhompKingBoss] = 40,
    [id_bhvPiranhaPlant] = 7,
    [id_bhvBulletBill] = 5,
    --[id_bhvThwomp] = 90,
    --[id_bhvThwomp2] = 90,
    -- CM
    [id_bhvSpindrift] = 2,
    [id_bhvMrBlizzard] = 20,
    -- BBH
    [id_bhvBoo] = 3,
    [id_bhvGhostHuntBoo] = 3,
    [id_bhvFlyingBookend] = 1,
    [id_bhvHauntedChair] = 1,
    [id_bhvBooWithCage] = 3,
    [id_bhvMerryGoRoundBoo] = 3,
    [id_bhvBalconyBigBoo] = 10,
    [id_bhvGhostHuntBigBoo] = 10,
    [id_bhvMerryGoRoundBigBoo] = 10,
    [id_bhvMadPiano] = 40,
    -- LLL
    [id_bhvMrI] = 30,
    [id_bhvSmallBully] = 30,
    [id_bhvBigBully] = 100,
    [id_bhvBigBullyWithMinions] = 100,
    -- SSL
    [id_bhvPokey] = 2,
    [id_bhvPokeyBodyPart] = 2,
    [id_bhvKlepto] = 1,
    [id_bhvFlyGuy] = 1,
    [id_bhvEyerokHand] = 30,
    [id_bhvJumpingBox] = 3,
    -- HMC
    [id_bhvScuttlebug] = 2,
    [id_bhvSnufit] = 1,
    [id_bhvSwoop] = 1,
    [id_bhvBigBoulder] = 8,
    -- THI
    [id_bhvFirePiranhaPlant] = 1,
    [id_bhvChuckya] = 17,
    [id_bhvEnemyLakitu] = 1,
    [id_bhvSpiny] = 2,
    [id_bhvWigglerBody] = 0,
    [id_bhvWigglerHead] = 6,
    -- TTM
    [id_bhvMontyMole] = 1,
    -- WDW
    [id_bhvSkeeter] = 1,
    [id_bhvHiddenObject] = 7,
    -- SL
    [id_bhvSmallChillBully] = 30,
    [id_bhvBigChillBully] = 100,
    [id_bhvMoneybag] = 2,
    -- BOWSER
    [id_bhvBowser] = 80,
    [id_bhvBowserBomb] = 10
}

-- Detect if SR enemies are present
if (bhvSMSRShyGuy) then
    -- Everything here seems to have the value 1 set instead. I'll  keep it like this for now
    healthtable[bhvSMSRSmallBee] = 0.5
    healthtable[bhvSMSRShyGuy] = 1.5
    healthtable[bhvSMSRBreakableWindow] = 3
    healthtable[bhvSMSRBreakableFloor] = 3
    healthtable[bhvSMSRBreakableRock] = 3
    healthtable[bhvSMSRWigglerHead] = 6
end

hook_event(HOOK_ON_OBJECT_LOAD, function(o)
    o.oMmxHealth = 1
    o.oMmxInitialHealth = 1
    o.oMmxHealthInitialized = 0
    if healthtable[get_id_from_behavior(o.behavior)] then
        o.oMmxHealthInitialized = 1
        o.oMmxHealth = healthtable[get_id_from_behavior(o.behavior)]
        o.oMmxInitialHealth = healthtable[get_id_from_behavior(o.behavior)]
    end
end)

function enemies_update()
    local bowser_obj = find_object_with_behavior(get_behavior_from_id(id_bhvBowser))
    if bowser_obj ~= nil then
        if bowser_obj.oAction == 4 and bowser_obj.oMmxHealth <= 0 then
            bowser_obj.oForwardVel = 0
        end
    end

    local kingbobomb_obj = find_object_with_behavior(get_behavior_from_id(id_bhvKingBobomb))
    if kingbobomb_obj ~= nil then
        if kingbobomb_obj.oAction == 0 and kingbobomb_obj.oMmxHealth < healthtable[id_bhvKingBobomb] then
            kingbobomb_obj.oMmxHealth = healthtable[id_bhvKingBobomb]
        end
    end

    local whompking_obj = find_object_with_behavior(get_behavior_from_id(id_bhvWhompKingBoss))
    if whompking_obj ~= nil then
        if whompking_obj.oAction == 0 and whompking_obj.oMmxHealth < healthtable[id_bhvWhompKingBoss] then
            whompking_obj = healthtable[id_bhvWhompKingBoss]
        end
    end
end

function set_health_for_overridden(obj, key)
    if obj.oMmxHealthInitialized ~= 1 and healthtable[key] then
        obj.oMmxHealthInitialized = 1
        obj.oMmxHealth = healthtable[key]
        obj.oMmxInitialHealth = healthtable[key]
        if obj.oSyncID ~= 0 then
            --network_send_object(obj, false)
        end
    end
end

hook_event(HOOK_UPDATE, enemies_update)