local move_object_to_limb = move_object_to_limb

E_model_gaea_giga = smlua_model_util_get_id("gaea_giga_geo")
E_model_gaea_giga_windup = smlua_model_util_get_id("gaea_giga_windup_geo")
E_model_gaea_dash_fx = smlua_model_util_get_id("gaea_dash_fx_geo")

function spawn_gaea_gigaattack(m, id)
    local hitboxId
    if id == nil then
        hitboxId = assign_id_to_hitbox(m)
        network_send(true, { type = 'gaea_gigaattack', id = hitboxId, m = gNetworkPlayers[m.playerIndex].globalIndex})
    else
        hitboxId = id
    end
    spawn_non_sync_object(
        id_bhvGaeaGigaAttack, E_MODEL_NONE, m.pos.x + sins(m.faceAngle.y) * 175, m.pos.y + 90, m.pos.z + coss(m.faceAngle.y) * 175,
        function(obj)
            obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
            obj.oHitboxGlobalIndex = hitboxId
        end
    )
end

local gaea_giga_attack_init = function(o)
    obj_set_model_extended(o, E_model_gaea_giga)
    o.oFlags = (OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE | OBJ_FLAG_SET_FACE_ANGLE_TO_MOVE_ANGLE)
    spawn_non_sync_object(id_bhvHitbox, E_MODEL_NONE, o.oPosX, o.oPosY, o.oPosZ, function(obj)
        obj.oOwner = o.oOwner
        obj.oHitboxType = HITBOX_BURST_GAEA_GIGAATTACK
        obj.oHitboxGlobalIndex = o.oHitboxGlobalIndex
        obj.oHitboxDamage = 7
        obj.hitboxRadius = 150
        obj.hitboxHeight = 300
        obj.hitboxDownOffset = 150
        obj.oHitboxIsMultiHit = true
        obj.oHitboxWaitTimesBetweenHits = 4
        obj.parentObj = o
    end)
    set_hitbox_pos_and_angle_to_obj_pos_angle(o)
end

local gaea_giga_attack_loop = function(o)
    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]
    obj_scale(o, 1.9)
    if o.oTimer > 22 or (m.action ~= ACT_GAEA_GIGAATTACK and m.action ~= ACT_AIR_GAEA_GIGAATTACK) then
        obj_mark_for_deletion(o)
    end
    local mmx = gMmxStates[m.playerIndex]
    o.oPosX = m.pos.x + sins(m.faceAngle.y) * 175 + mmx.dPrevPos.x
    o.oPosY = m.pos.y + 90 + mmx.dPrevPos.y
    o.oPosZ = m.pos.z + coss(m.faceAngle.y) * 175 + mmx.dPrevPos.z
    o.oAnimState = o.oAnimState + 1
    if o.oAnimState > 3 then
        o.oAnimState = 0
    end
    set_hitbox_pos_and_angle_to_obj_pos_angle(o)
end

local gaea_giga_windup_init = function(o)
    obj_set_model_extended(o, E_model_gaea_giga_windup)
    o.oFlags = (OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE | OBJ_FLAG_SET_FACE_ANGLE_TO_MOVE_ANGLE)
    cur_obj_hide()
    o.oAnimState = 1
end

local gaea_giga_windup_loop = function(o)
    obj_scale(o, 0.45)
    if o.oTimer == 1 then
        cur_obj_unhide()
    end
    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]
    if o.oTimer > 15 or (m.action ~= ACT_GAEA_GIGAATTACK and m.action ~= ACT_AIR_GAEA_GIGAATTACK) then
        obj_mark_for_deletion(o)
    end
    o.oAnimState = o.oAnimState + 1
    if o.oAnimState > 2 then
        o.oAnimState = 1
    end

    local front = -5
    local up = -12
    local side = 20
    local limb = 0

    move_object_to_limb(o, limb, up, side, front)
end


local gaea_dash_fx_init = function(o)
    o.oFlags = (OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE | OBJ_FLAG_SET_FACE_ANGLE_TO_MOVE_ANGLE |
    OBJ_FLAG_SET_FACE_YAW_TO_MOVE_YAW)
    obj_set_model_extended(o, E_model_gaea_dash_fx)
    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]
    local yOffset = 0
    if m.action == ACT_AIR_DASH then
        yOffset = 30
    end
    o.oPosX = m.pos.x
    o.oPosY = m.pos.y + yOffset
    o.oPosZ = m.pos.z
    if m.action == ACT_DASH then
        cur_obj_align_gfx_with_floor()
    end
end

local gaea_dash_fx_loop = function(o)
    o.oAnimState = o.oAnimState + 1
    if o.oAnimState > 4 then
        o.oAnimState = 0
    end
    
    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]

    local yOffset = 0
    if m.action == ACT_AIR_DASH then
        yOffset = 30
    end
    o.oPosX = m.pos.x
    o.oPosY = m.pos.y + yOffset
    o.oPosZ = m.pos.z
    if m.action == ACT_DASH then
        cur_obj_align_gfx_with_floor()
    end
    if m.action ~= ACT_DASH and m.action ~= ACT_AIR_DASH then
        obj_mark_for_deletion(o)
    end
end

id_bhvGaeaGigaAttack = hook_behavior(nil, OBJ_LIST_UNIMPORTANT, false, gaea_giga_attack_init, gaea_giga_attack_loop)
id_bhvGaeaGigaWindUp = hook_behavior(nil, OBJ_LIST_UNIMPORTANT, false, gaea_giga_windup_init, gaea_giga_windup_loop)
id_bhvGaeaGigaDashFx = hook_behavior(nil, OBJ_LIST_UNIMPORTANT, false, gaea_dash_fx_init, gaea_dash_fx_loop)