-----------------------------------------------------------------
----- LOCALIZED FUNCTIONS ---------------------------------------
-----------------------------------------------------------------
local sins, coss, network_player_from_global_index, obj_mark_for_deletion, obj_spawn_loot_yellow_coins, mmx_play_sound,
 nearest_mario_state_to_object, obj_get_nearest_object_with_behavior_id, obj_check_hitbox_overlap, cur_obj_scale, obj_scale, network_send_object,
 atan2s, calculate_yaw, network_init_object, network_send, spawn_non_sync_object =
 sins, coss, network_player_from_global_index, obj_mark_for_deletion, obj_spawn_loot_yellow_coins, mmx_play_sound,
  nearest_mario_state_to_object, obj_get_nearest_object_with_behavior_id, obj_check_hitbox_overlap, cur_obj_scale, obj_scale, network_send_object,
  atan2s, calculate_yaw, network_init_object, network_send, spawn_non_sync_object


function spawn_napalm(m, grounded, id)
    local mGfx = m.marioObj.header.gfx
    local angl = m.faceAngle.y - 6000
    local hitboxId
    if id == nil then
        local napalmGrounded = 0
        if grounded then
            napalmGrounded = 1
        end
        hitboxId = assign_id_to_hitbox(m)
        network_send(true, { type = 'napalm', grounded = napalmGrounded, id = hitboxId, m = gNetworkPlayers[m.playerIndex].globalIndex})
    else
        hitboxId = id
    end
    mmx_play_sound(SOUND_VILE_NAPALM_SHOT, m.pos, 0.47)
    if (grounded) then
        spawn_non_sync_object(id_bhvLegNapalm, E_model_leg_napalm, mGfx.pos.x + sins(angl) * 50, mGfx.pos.y + 10, mGfx.pos.z + coss(angl) * 50 , function(obj)
            obj.oMoveAngleYaw = m.faceAngle.y
            obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
            obj.oForwardVel = 90
            obj.oVelY = 25
            obj.oHitboxGlobalIndex = hitboxId
        end)
    else
        spawn_non_sync_object(id_bhvLegNapalm, E_model_leg_napalm, mGfx.pos.x + sins(angl) * 50, mGfx.pos.y + 10, mGfx.pos.z + coss(angl) * 50 , function(obj)
            obj.oMoveAngleYaw = m.faceAngle.y
            obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
            obj.oForwardVel = 25
            obj.oHitboxGlobalIndex = hitboxId
        end)
    end
end

-----------------------------------------------------------------
-----------------------------------------------------------------
----- BEHAVIORS -------------------------------------------------
-----------------------------------------------------------------
-----------------------------------------------------------------

--- LEG NAPALM
local leg_napalm_init = function(o)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.oBuoyancy = 3.5
    obj_scale(o, 0.7)
    o.oGraphYOffset = 20
    o.oGravity = 5
    o.oFriction = 0.8
end

local leg_napalm_loop = function(o)
    if o.oTimer < 18 then
        object_step()
    end
    if o.oTimer == 18 then
        cur_obj_hide()
        spawn_non_sync_object(id_bhvWhitePuffSmoke2, E_MODEL_BOWSER_FLAMES, o.oPosX , o.oPosY + 20 , o.oPosZ, function(obj)
            obj.header.gfx.scale.x = 2.5
            obj.header.gfx.scale.y = 6
            obj.header.gfx.scale.z = 2.5
            obj.oOpacity = 200
        end)
    end
    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]
    
    if o.oTimer >= 20 then
        
        spawn_non_sync_object(id_bhvLegNapalmExplosion, E_MODEL_EXPLOSION, o.oPosX, o.oPosY, o.oPosZ, function(obj)
            obj.oOwner = o.oOwner
            obj.oHitboxGlobalIndex = o.oHitboxGlobalIndex
            obj.oHitboxDamage = 7
        end)
        
        obj_mark_for_deletion(o)
    end
    
end

-- LEG NAPALM EXPLOSION
local leg_napalm_explosion_init = function(o)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.header.gfx.node.flags = o.header.gfx.node.flags | GRAPH_RENDER_BILLBOARD
    mmx_play_sound(SOUND_VILE_NAPALM_EXPLODE, {x = o.oPosX, y = o.oPosY, z = o.oPosZ}, 0.75)
    set_environmental_camera_shake(SHAKE_ENV_EXPLOSION)
    for i = 0, 8, 1 do
        local angle = 8192 * i
        spawn_non_sync_object(id_bhvWhitePuffSmoke2, E_MODEL_EXPLOSION, o.oPosX + 150 * sins(angle), o.oPosY + 50, o.oPosZ + 150 * coss(angle), function(obj)
            obj.header.gfx.scale.x = 0.5
            obj.header.gfx.scale.y = 0.5
            obj.header.gfx.scale.z = 0.5
            obj.oOpacity = 200
        end)
    end
    spawn_non_sync_object(id_bhvWhitePuffSmoke2, E_MODEL_EXPLOSION, o.oPosX, o.oPosY, o.oPosZ, function(obj)
        obj.header.gfx.scale.x = 1.3
        obj.header.gfx.scale.y = 1.1
        obj.header.gfx.scale.z = 1.3
        obj.oOpacity = 200
    end)
    o.oOpacity = 255
    o.header.gfx.scale.x = 1.7
    o.header.gfx.scale.y = 2.3
    o.header.gfx.scale.z = 1.7
    o.hitboxRadius            = 200
    o.hitboxHeight            = 570
    o.hitboxDownOffset        = 150
    o.oGraphYOffset = 200
    set_hitbox_pos_and_angle_to_obj_pos_angle(o)
end

local leg_napalm_explosion_loop = function(o)
    o.header.gfx.scale.x = 1.1
    o.header.gfx.scale.y = 1.45
    o.header.gfx.scale.z = 1.1

    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]

    if (o.oTimer == 2) then
        spawn_non_sync_object(id_bhvHitbox, E_MODEL_NONE, o.oPosX, o.oPosY, o.oPosZ, function(obj)
            obj.oOwner = o.oOwner
            obj.oHitboxType = HITBOX_BURST_LEG_NAPALM
            obj.oHitboxGlobalIndex = o.oHitboxGlobalIndex
            obj.oHitboxDamage = o.oHitboxDamage
            obj.hitboxRadius = o.hitboxRadius
            obj.hitboxHeight = o.hitboxHeight
            obj.hitboxDownOffset = o.hitboxDownOffset
            obj.parentObj = o
        end)
    end
    o.oAnimState = o.oAnimState + 1
    if (o.oTimer == 9) then
        if (find_water_level(o.oPosX, o.oPosZ) > o.oPosY) then
            for i = 0, 40, 1 do 
                --spawn_object(o, MODEL_WHITE_PARTICLE_SMALL, bhvBobombExplosionBubble)
                spawn_non_sync_object(id_bhvBobombExplosionBubble, E_MODEL_WHITE_PARTICLE_SMALL, o.oPosX, o.oPosY, o.oPosZ, nil)
            end                
        else
            --spawn_object(o, MODEL_SMOKE, bhvBobombBullyDeathSmoke)
            spawn_non_sync_object(id_bhvBobombBullyDeathSmoke, E_MODEL_SMOKE, o.oPosX, o.oPosY + 200, o.oPosZ, nil)
        end
        o.activeFlags = ACTIVE_FLAG_DEACTIVATED
        obj_mark_for_deletion(o)
    end

    o.oOpacity = o.oOpacity - 14

    cur_obj_scale(o.oTimer / 9.0 + 1.0)
    set_hitbox_pos_and_angle_to_obj_pos_angle(o)
end

----------------------------
--BEHAVIORS REGISTRY--------
----------------------------
id_bhvLegNapalm = hook_behavior(nil, OBJ_LIST_GENACTOR, false, leg_napalm_init, leg_napalm_loop)
id_bhvLegNapalmExplosion = hook_behavior(nil, OBJ_LIST_GENACTOR, false, leg_napalm_explosion_init, leg_napalm_explosion_loop)