-----------------------------------------------------------------
----- LOCALIZED FUNCTIONS ---------------------------------------
-----------------------------------------------------------------
local sins, coss, cur_obj_resolve_wall_collisions, obj_mark_for_deletion, network_player_from_global_index,
 obj_scale, calculate_pitch, obj_move_xyz, spawn_non_sync_object, obj_build_transform_relative_to_parent,
 obj_set_throw_matrix_from_transform, active_player = 
sins, coss, cur_obj_resolve_wall_collisions, obj_mark_for_deletion, network_player_from_global_index,
 obj_scale, calculate_pitch, obj_move_xyz, spawn_non_sync_object, obj_build_transform_relative_to_parent,
 obj_set_throw_matrix_from_transform, active_player

-----------------------------------------------------------
--- FUNCTIONS ---------------------------------------------
-----------------------------------------------------------

function spawn_charge(m, charge_level)
    local mGfx = m.marioObj.header.gfx
    if (charge_level == 1) then
        spawn_non_sync_object(id_bhvChargeSpheres, E_model_energy_charge1, mGfx.pos.x, mGfx.pos.y + 80, mGfx.pos.z, function (obj)
            obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
            obj.oMoveAngleRoll = 0
            obj.oChargeIndex = 1
        end)
    elseif (charge_level == 2) then
        spawn_non_sync_object(id_bhvCharge2Back, E_model_charge2_back, mGfx.pos.x, mGfx.pos.y + 80, mGfx.pos.z, function (obj)
            obj.oChargeMinSize = 1.1
            obj.oChargeScaleDownFactor = 0.14
            obj.oChargeSize = 2.1
            obj.oChargeRot = 300
            obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
            obj.oChargeIndex = 2
        end)
        spawn_non_sync_object(id_bhvCharge2Back, E_model_charge2_front, mGfx.pos.x, mGfx.pos.y + 80, mGfx.pos.z, function (obj)
            obj.oChargeMinSize = 1.6
            obj.oChargeScaleDownFactor = 0.09
            obj.oChargeSize = 2.8
            obj.oChargeRot = 100
            obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
            obj.oChargeIndex = 2
        end)
        spawn_non_sync_object(id_bhvChargeSpheres, E_model_energy_charge2, mGfx.pos.x, mGfx.pos.y + 80, mGfx.pos.z, function (obj)
            obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
            obj.oMoveAngleRoll = 0
            obj.oChargeIndex = 2
        end)
    elseif (charge_level == 3) then
        spawn_non_sync_object(id_bhvCharge2Back, E_model_charge3_back_lightarmor, mGfx.pos.x, mGfx.pos.y + 80, mGfx.pos.z, function (obj)
            obj.oChargeMinSize = 1.1
            obj.oChargeScaleDownFactor = 0.14
            obj.oChargeSize = 2.1
            obj.oChargeRot = 300
            obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
            obj.oChargeIndex = 3
        end)
        spawn_non_sync_object(id_bhvCharge2Back, E_model_charge3_front_lightarmor, mGfx.pos.x, mGfx.pos.y + 80, mGfx.pos.z, function (obj)
            obj.oChargeMinSize = 1.6
            obj.oChargeScaleDownFactor = 0.09
            obj.oChargeSize = 2.8
            obj.oChargeRot = 100
            obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
            obj.oChargeIndex = 3
        end)
        spawn_non_sync_object(id_bhvChargeSpheres, E_model_energy_charge3_lightarmor, mGfx.pos.x, mGfx.pos.y + 80, mGfx.pos.z, function (obj)
            obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
            obj.oMoveAngleRoll = 0
            obj.oChargeIndex = 3
        end)
    end
end

-----------------------------------------------------------
--- PARTICLES ---------------------------------------------
-----------------------------------------------------------

--- DASH TRAILS
local trail_init = function(o)
    o.oFlags = (OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE | OBJ_FLAG_SET_FACE_ANGLE_TO_MOVE_ANGLE)
    o.oOpacity = 100
    if o.oOwnerChar then
        if o.oOwnerChar == 1 then
            -- Vile
            o.oOpacity = 75
        elseif o.oOwnerChar == 2 then
            -- X Command Mission
            o.oOpacity = 70
        end
    end
    
    cur_obj_hide()
end

local trail_loop = function(o)
    if cur_obj_resolve_wall_collisions() == 0 then
        obj_move_xyz(o, o.oVelX, o.oVelY, o.oVelZ)
    end

    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]
    o.header.gfx.animInfo.curAnim = m.marioObj.header.gfx.animInfo.curAnim
    o.header.gfx.animInfo.animFrame = m.marioObj.header.gfx.animInfo.animFrame
    o.header.gfx.animInfo.animFrameAccelAssist = m.marioObj.header.gfx.animInfo.animFrameAccelAssist
    if m.action == ACT_DASH then
        cur_obj_align_gfx_with_floor()
    end

    if o.oTimer == 1 then
        cur_obj_unhide()
    end
    if o.oTimer >= 2 then
        o.oOpacity = o.oOpacity - 36
    end

    if o.oOpacity <= 0 then
        obj_mark_for_deletion(o)
    end
end



--- CHARGE 2 EFFECTS (highest charge level)
-- front
local charge2_front_init = function(o)
    o.oFlags = (OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE | OBJ_FLAG_SET_FACE_ANGLE_TO_MOVE_ANGLE)
    o.oOpacity = 0xA9
    obj_scale(o, 1.75)
    o.hookRender = 1
end

local charge2_front_loop = function(o)
    o.hookRender = 1
    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    local mGfx = m.marioObj.header.gfx
    o.oPosX = mGfx.pos.x
    o.oPosY = mGfx.pos.y + 90 - MODEL_Y_OFFSET
    o.oPosZ = mGfx.pos.z
    o.oMoveAngleYaw = m.faceAngle.y - 16384 + 4096 * o.oTimer
    if o.oTimer >= 8 or not active_player(m) then
        obj_mark_for_deletion(o)
    end  
end

-- back
local charge2_back_init = function(o)
    o.oFlags = (OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE | OBJ_FLAG_SET_FACE_ANGLE_TO_MOVE_ANGLE | OBJ_FLAG_SET_FACE_YAW_TO_MOVE_YAW)
    o.oOpacity = 255
    o.header.gfx.scale.x = o.oChargeSize
    o.header.gfx.scale.y = o.oChargeSize
    o.header.gfx.scale.z = o.oChargeSize
    cur_obj_hide()
end

local charge2_back_loop = function(o)
    if (o.oTimer == 1) then
        cur_obj_unhide()
    end
    o.hookRender = 1
    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    local mGfx = m.marioObj.header.gfx

    if (o.header.gfx.scale.x >= o.oChargeMinSize) then
        o.header.gfx.scale.x = o.header.gfx.scale.x - o.oChargeScaleDownFactor
        o.header.gfx.scale.y = o.header.gfx.scale.y - o.oChargeScaleDownFactor
        o.header.gfx.scale.z = o.header.gfx.scale.z - o.oChargeScaleDownFactor
    else
        o.header.gfx.scale.x = o.oChargeSize
        o.header.gfx.scale.y = o.oChargeSize
        o.header.gfx.scale.z = o.oChargeSize
    end

    local m0 = gMarioStates[0]
    o.oMoveAngleYaw = m0.area.camera.yaw

    local pitch = calculate_pitch(m0.pos, m0.area.camera.pos)
    o.oMoveAnglePitch = -pitch
    
    o.oMoveAngleRoll = o.oMoveAngleRoll + o.oChargeRot

    o.oPosX = mGfx.pos.x
    o.oPosY = mGfx.pos.y + 90 - MODEL_Y_OFFSET
    o.oPosZ = mGfx.pos.z
    
    if (s.x_charge_spawned ~= o.oChargeIndex or not active_player(m)) then
        obj_mark_for_deletion(o)
    end  
end

--- CHARGE SPHERES (both charge levels)
local charge_spheres_init = function(o)
    o.oFlags = (OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE | OBJ_FLAG_SET_FACE_ANGLE_TO_MOVE_ANGLE | OBJ_FLAG_SET_FACE_YAW_TO_MOVE_YAW)
    --o.header.gfx.node.flags = o.header.gfx.node.flags | GRAPH_RENDER_BILLBOARD
    o.header.gfx.scale.x = 2.4
    o.header.gfx.scale.y = 2.4
    o.header.gfx.scale.z = 2.4
    if (o.oMoveAngleRoll == 8192) then
        o.header.gfx.scale.x = 2.15
        o.header.gfx.scale.y = 2.15
        o.header.gfx.scale.z = 2.15
    end
    cur_obj_hide()
end

local charge_spheres_loop = function(o)
    if (o.oTimer == 1) then
        cur_obj_unhide()
    end
    o.hookRender = 1
    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]
    local m0 = gMarioStates[0]
    local s = gPlayerSyncTable[m.playerIndex]

    -- CHECK IN MULTIPLAYER
    o.oMoveAngleYaw = m0.area.camera.yaw
    local pitch = calculate_pitch(m0.pos, m0.area.camera.pos)
    o.oMoveAnglePitch = -pitch
    
    --o.oMoveAngleRoll = o.oMoveAngleRoll + 700
    local mGfx = m.marioObj.header.gfx
    o.oPosX = mGfx.pos.x
    o.oPosY = mGfx.pos.y + 95 - MODEL_Y_OFFSET
    o.oPosZ = mGfx.pos.z
    o.header.gfx.scale.x = o.header.gfx.scale.x - 0.175
    o.header.gfx.scale.y = o.header.gfx.scale.y - 0.175
    o.header.gfx.scale.z = o.header.gfx.scale.z - 0.175
    if o.oTimer >= 10 then
        cur_obj_hide()
    end

    if (s.x_charge_spawned ~= o.oChargeIndex) or o.oTimer >= 11 or not active_player(m) then
        obj_mark_for_deletion(o)
    end 

    if o.oTimer == 6 then

        if (o.oChargeIndex == 1) then
            spawn_non_sync_object(id_bhvChargeSpheres, E_model_energy_charge1, mGfx.pos.x, mGfx.pos.y + 90 - MODEL_Y_OFFSET, mGfx.pos.z, function (obj)
                obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
                if o.oMoveAngleRoll == 8192 then
                    obj.oMoveAngleRoll = 0
                else
                    obj.oMoveAngleRoll = 8192
                end
                obj.oChargeIndex = 1
            end)
        elseif (o.oChargeIndex == 2) then
            spawn_non_sync_object(id_bhvChargeSpheres, E_model_energy_charge2, mGfx.pos.x, mGfx.pos.y + 90 - MODEL_Y_OFFSET, mGfx.pos.z, function (obj)
                obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
                if o.oMoveAngleRoll == 8192 then
                    obj.oMoveAngleRoll = 0
                else
                    obj.oMoveAngleRoll = 8192
                end
                obj.oChargeIndex = 2
            end)
        elseif (o.oChargeIndex == 3) then
            spawn_non_sync_object(id_bhvChargeSpheres, E_model_energy_charge3_lightarmor, mGfx.pos.x, mGfx.pos.y + 90 - MODEL_Y_OFFSET, mGfx.pos.z, function (obj)
                obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
                if o.oMoveAngleRoll == 8192 then
                    obj.oMoveAngleRoll = 0
                else
                    obj.oMoveAngleRoll = 8192
                end
                obj.oChargeIndex = 3
            end)
        end
    end
end

--- WALL SPARK
local wallspark_init = function(o)
    o.oFlags = (OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE | OBJ_FLAG_SET_FACE_ANGLE_TO_MOVE_ANGLE)
    o.hookRender = 1
end

local wallspark_loop = function(o)
    obj_scale(o, o.header.gfx.scale.x + 0.55)
    o.hookRender = 1

    if o.oTimer > 4 then
        obj_mark_for_deletion(o)
    end
end



--- SHOT RING
local shot_ring_init = function(o)
    o.oFlags = (OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE | OBJ_FLAG_SET_FACE_ANGLE_TO_MOVE_ANGLE)
    o.oOpacity = 255
    obj_scale(o, 0.3)
    if obj_get_model_id_extended(o) == E_model_shot3_ring then
        o.hookRender = 1
    end
end

local shot_ring_loop = function(o)
    if obj_get_model_id_extended(o) == E_model_shot3_ring then
        o.hookRender = 1
    end
    o.oVelX = o.oForwardVel * sins(o.oMoveAngleYaw) * coss(o.oMoveAnglePitch)
    o.oVelY = o.oForwardVel * sins(o.oMoveAnglePitch)
    o.oVelZ = o.oForwardVel * coss(o.oMoveAngleYaw) * coss(o.oMoveAnglePitch)

    if cur_obj_resolve_wall_collisions() == 0 then
        obj_move_xyz(o, o.oVelX, o.oVelY, o.oVelZ)
    end

    obj_scale(o, o.header.gfx.scale.x + 0.45)

    if o.oTimer >= 3 then
        o.oOpacity = o.oOpacity - 12
    end

    if o.oTimer > 4 then
        obj_mark_for_deletion(o)
    end
end



--- SHOT TRAIL
local shot_trail_ball_init = function(o)
    o.oFlags = (OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE | OBJ_FLAG_SET_FACE_ANGLE_TO_MOVE_ANGLE)
    o.oOpacity = 255
    if (o.oShotType == SHOT_TYPE_X_GIGA_SMALL or o.oShotType == SHOT_TYPE_X_LIGHT_SMALL) then
        obj_scale(o, 1.05)
    else
        obj_scale(o, 0.7)
    end
    if obj_get_model_id_extended(o) ~= E_model_shot_gaea_trail then
        o.hookRender = 1
    end
end

local shot_trail_ball_loop = function(o)
    if obj_get_model_id_extended(o) ~= E_model_shot_gaea_trail then
        o.hookRender = 1
    end

    if cur_obj_resolve_wall_collisions() == 0 then
        obj_move_xyz(o, o.oVelX, o.oVelY, o.oVelZ)
    end

    if (o.oShotType == SHOT_TYPE_X_GIGA_SMALL or o.oShotType == SHOT_TYPE_X_LIGHT_SMALL) then
        obj_scale(o, o.header.gfx.scale.x - 0.08)
        if o.oTimer > 5 then
            obj_mark_for_deletion(o)
        end
    else
        obj_scale(o, o.header.gfx.scale.x - 0.1)
        if o.oTimer > 4 then
            obj_mark_for_deletion(o)
        end
    end
end



--- DASH EFFECT (not trails)
local dash_fx_init = function(o)
    o.oFlags = (OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE | OBJ_FLAG_SET_FACE_ANGLE_TO_MOVE_ANGLE | OBJ_FLAG_SET_FACE_YAW_TO_MOVE_YAW)
    obj_scale(o, 0.45)
    obj_set_model_extended(o, E_model_mmx_zero_dash_fx)
    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]
    o.hookRender = 1
    o.parentObj = m.marioObj
end

local dash_fx_loop = function(o)
    
    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]
    o.hookRender = 1

    o.oPosX = m.pos.x - sins(o.oMoveAngleYaw) * 75 * (1 - sins(o.oMoveAnglePitch))
    o.oPosY = m.pos.y + 85 + sins(o.oMoveAnglePitch) * 85
    o.oPosZ = m.pos.z - coss(o.oMoveAngleYaw) * 75 * (1 - sins(o.oMoveAnglePitch))
    cur_obj_align_gfx_with_floor()
    if o.oTimer % 2 == 0 and o.oTimer < 3 then
        obj_scale(o, 0.45)
    else
        obj_scale_xyz(o, 0.7, 0.7, 0.8)
    end
    if o.oTimer == 3 then
        obj_scale_xyz(o, 0.4, 0.4, 0.9)
    elseif o.oTimer == 4 then
        obj_scale_xyz(o, 0.35, 0.35, 0.8)
    end
    if o.oTimer == 5 or m.action ~= ACT_VILE_DASH then
        obj_mark_for_deletion(o)
    end
end

--------------------------------------------------
--- REGISTRING BEHAVIORS -------------------------
--------------------------------------------------


id_bhvTrail = hook_behavior(nil, OBJ_LIST_UNIMPORTANT, false, trail_init, trail_loop)
id_bhvCharge2Front = hook_behavior(nil, OBJ_LIST_UNIMPORTANT, false, charge2_front_init, charge2_front_loop)
id_bhvCharge2Back = hook_behavior(nil, OBJ_LIST_UNIMPORTANT, false, charge2_back_init, charge2_back_loop)
id_bhvChargeSpheres = hook_behavior(nil, OBJ_LIST_UNIMPORTANT, false, charge_spheres_init, charge_spheres_loop)
id_bhvShotRing = hook_behavior(nil, OBJ_LIST_UNIMPORTANT, false, shot_ring_init, shot_ring_loop)
id_bhvShotTrailBall = hook_behavior(nil, OBJ_LIST_UNIMPORTANT, false, shot_trail_ball_init, shot_trail_ball_loop)
id_bhvWallspark = hook_behavior(nil, OBJ_LIST_UNIMPORTANT, false, wallspark_init, wallspark_loop)
id_bhvDashFx = hook_behavior(nil, OBJ_LIST_UNIMPORTANT, false, dash_fx_init, dash_fx_loop)

--------------------------------------------------
--- RENDER ---------------------------------------
--------------------------------------------------

local combinerFixModels = {
    [E_model_mmx_zero_dash_fx] = true,
    [E_model_shot3_ring] = true,
    [E_model_shot3_particle] = true,
    [E_model_shot_max] = true,
    [E_model_shot_dmg] = true,
    [E_model_saber_dmg] = true,
    [E_model_wallspark] = true,
}

local chargeModelColor = {
    [E_model_energy_charge1] = { r = 100, g = 220, b = 255, a = 255},
    [E_model_energy_charge2] = { r = 255, g = 245, b = 170, a = 255},
    [E_model_charge2_back] = { r = 255, g = 245, b = 170, a = 255},
    [E_model_charge2_front] = { r = 255, g = 245, b = 170, a = 255},
    [E_model_energy_charge3_lightarmor] = { r = 255, g = 210, b = 240, a = 255},
    [E_model_charge3_back_lightarmor] = { r = 255, g = 210, b = 240, a = 255},
    [E_model_charge3_front_lightarmor] = { r = 255, g = 210, b = 240, a = 255},
    [E_model_shot_max_bubble] = { r = 255, g = 210, b = 240, a = 150}
}

hook_event(HOOK_ON_OBJECT_RENDER, function(o)
    if o == nil or o.behavior == nil then
        return
    end
    if combinerFixModels[obj_get_model_id_extended(o)] then
        local mat = 0
        local dl = cast_graph_node(o.header.gfx.sharedChild.children)
        gfx_parse(dl.displayList, function(cmd, op)
            if op == G_SETCOMBINE then             
                if mat == 2 then
                    gfx_set_combine_lerp(cmd, 0, 0, 0, G_CCMUX_1, 0, 0, 0, G_CCMUX_ENVIRONMENT, 0, 0, 0, G_ACMUX_1, 0, 0, 0, G_ACMUX_ENVIRONMENT)
                else
                    gfx_set_combine_lerp(cmd, 0, 0, 0, G_CCMUX_PRIMITIVE, 0, 0, 0, G_CCMUX_ENVIRONMENT, 0, 0, 0, G_ACMUX_PRIMITIVE, 0, 0, 0, G_ACMUX_ENVIRONMENT)
                end
                mat = mat + 1   
            end   
        end)
    elseif chargeModelColor[obj_get_model_id_extended(o)] then
        local dl = cast_graph_node(o.header.gfx.sharedChild.children)
        gfx_parse(dl.displayList, function(cmd, op)
            if op == G_SETPRIMCOLOR then
                local r = chargeModelColor[obj_get_model_id_extended(o)].r
                local g = chargeModelColor[obj_get_model_id_extended(o)].g
                local b = chargeModelColor[obj_get_model_id_extended(o)].b
                local a = chargeModelColor[obj_get_model_id_extended(o)].a
                gfx_set_command(cmd, "gsDPSetPrimColor", 255, 255, r, g, b, a)
            elseif op == G_SETCOMBINE then
                if obj_get_model_id_extended(o) == E_model_shot_max_bubble then
                    gfx_set_combine_lerp(cmd, G_CCMUX_PRIMITIVE, 0, G_CCMUX_ENVIRONMENT, 0, G_ACMUX_1, 0, G_CCMUX_PRIMITIVE, 0, G_CCMUX_PRIMITIVE, 0, G_CCMUX_ENVIRONMENT, 0, G_ACMUX_1, 0, G_CCMUX_PRIMITIVE, 0)  
                else
                    gfx_set_combine_lerp(cmd, G_CCMUX_PRIMITIVE, 0, G_CCMUX_ENVIRONMENT, 0, G_ACMUX_1, 0, G_CCMUX_TEXEL0, 0, G_CCMUX_PRIMITIVE, 0, G_CCMUX_ENVIRONMENT, 0, G_ACMUX_1, 0, G_CCMUX_TEXEL0, 0)
                end         
            end   
        end)
    end
end)
