-----------------------------------------------------------------
----- LOCALIZED FUNCTIONS ---------------------------------------
-----------------------------------------------------------------
local sins, coss, obj_mark_for_deletion, network_player_from_global_index,
 obj_scale, calculate_pitch, spawn_non_sync_object, atan2s, obj_scale_xyz, obj_get_model_id_extended, smlua_model_util_get_id,
 obj_set_model_extended, gfx_set_combine_lerp, gfx_parse, cast_graph_node =
sins, coss, obj_mark_for_deletion, network_player_from_global_index,
 obj_scale, calculate_pitch, spawn_non_sync_object, atan2s, obj_scale_xyz, obj_get_model_id_extended, smlua_model_util_get_id,
 obj_set_model_extended, gfx_set_combine_lerp, gfx_parse, cast_graph_node

-----------------------------------------------------------
--- MODELS ------------------------------------------------
-----------------------------------------------------------
E_model_zsaber_base = smlua_model_util_get_id("zero_zsaber_base_geo")

E_model_raikousen = smlua_model_util_get_id("zero_raikousen1_geo")
E_model_raikousen2 = smlua_model_util_get_id("zero_raikousen2_geo")
E_model_raikousen_blade = smlua_model_util_get_id("zero_raikousen_blade_geo")
E_model_lslash1 = smlua_model_util_get_id("zero_lslash1_geo")
E_model_lslash2 = smlua_model_util_get_id("zero_lslash2_geo")
E_model_lslash3 = smlua_model_util_get_id("zero_lslash3_geo")
E_model_lslash4 = smlua_model_util_get_id("zero_lslash4_geo")
E_model_lslash5 = smlua_model_util_get_id("zero_lslash5_geo")
E_model_lslash6 = smlua_model_util_get_id("zero_lslash6_geo")
E_model_lslash7 = smlua_model_util_get_id("zero_lslash7_geo")

E_model_lslash1_bz = smlua_model_util_get_id("zero_lslash1_bz_geo")
E_model_lslash2_bz = smlua_model_util_get_id("zero_lslash2_bz_geo")
E_model_lslash3_bz = smlua_model_util_get_id("zero_lslash3_bz_geo")
E_model_lslash4_bz = smlua_model_util_get_id("zero_lslash4_bz_geo")
E_model_lslash5_bz = smlua_model_util_get_id("zero_lslash5_bz_geo")
E_model_lslash6_bz = smlua_model_util_get_id("zero_lslash6_bz_geo")
E_model_lslash7_bz = smlua_model_util_get_id("zero_lslash7_bz_geo")

E_model_mslash2 = smlua_model_util_get_id("zero_mslash2_geo")
E_model_mslash3 = smlua_model_util_get_id("zero_mslash3_geo")

E_model_mslash2_bz = smlua_model_util_get_id("zero_mslash2_bz_geo")
E_model_mslash3_bz = smlua_model_util_get_id("zero_mslash3_bz_geo")

E_model_hslash1 = smlua_model_util_get_id("zero_hslash1_geo")
E_model_hslash2 = smlua_model_util_get_id("zero_hslash2_geo")
E_model_hslash3 = smlua_model_util_get_id("zero_hslash3_geo")
E_model_hslash4 = smlua_model_util_get_id("zero_hslash4_geo")

E_model_hslash1_bz = smlua_model_util_get_id("zero_hslash1_bz_geo")
E_model_hslash2_bz = smlua_model_util_get_id("zero_hslash2_bz_geo")
E_model_hslash3_bz = smlua_model_util_get_id("zero_hslash3_bz_geo")
E_model_hslash4_bz = smlua_model_util_get_id("zero_hslash4_bz_geo")

E_model_kuenzan = smlua_model_util_get_id("zero_kuenzan_geo")
E_model_kuenzan2 = smlua_model_util_get_id("zero_kuenzan2_geo")

E_model_kuenzan_bz = smlua_model_util_get_id("zero_kuenzan_bz_geo")
E_model_kuenzan2_bz = smlua_model_util_get_id("zero_kuenzan2_bz_geo")

E_model_shippuga = smlua_model_util_get_id("zero_shippuga_geo")

E_model_sentsuizan = smlua_model_util_get_id("zero_sentsuizan_geo")
E_model_sentsuizan_bz = smlua_model_util_get_id("zero_sentsuizan_bz_geo")

E_model_hyouretsuzan = smlua_model_util_get_id("zero_hyouretsuzan_geo")
E_model_hyouretsuzan_shard = smlua_model_util_get_id("zero_hyouretsuzan_shard_geo")

E_model_ryuenjin1 = smlua_model_util_get_id("zero_ryuenjin1new_geo")
E_model_ryuenjin2 = smlua_model_util_get_id("zero_ryuenjin2new_geo")

-----------------------------------------------------------
--- HELD SABERS -------------------------------------------
-----------------------------------------------------------

local sizeModifier = 0.75

local hitboxSpawnData = {
    [HITBOX_MELEE_LIGHT_SLASH] = function(o)
        o.hitboxRadius            = 85 * sizeModifier
        o.hitboxHeight            = 120 * sizeModifier
        o.hitboxDownOffset        = 60 * sizeModifier
        o.oHitboxIsMultiHit = 0
        o.oHitboxDamage = 2
        o.oHitboxHitstop = 1
    end,
    [HITBOX_MELEE_MEDIUM_SLASH] = function(o)
        o.hitboxRadius            = 105 * sizeModifier
        o.hitboxHeight            = 100 * sizeModifier
        o.hitboxDownOffset        = 50 * sizeModifier
        o.oHitboxIsMultiHit = 0
        o.oHitboxDamage = 2.5
        o.oHitboxHitstop = 1
    end,
    [HITBOX_MELEE_HEAVY_SLASH] = function(o)
        o.hitboxRadius            = 92 * sizeModifier
        o.hitboxHeight            = 140 * sizeModifier
        o.hitboxDownOffset        = 70 * sizeModifier
        o.oHitboxIsMultiHit = 1
        o.oHitboxDamage = 2.15
        o.oHitboxHitstop = 3
    end,
    [HITBOX_MELEE_AIR_SLASH] = function(o)
        o.hitboxRadius            = 107 * sizeModifier
        o.hitboxHeight            = 140 * sizeModifier
        o.hitboxDownOffset        = 82 * sizeModifier
        o.oHitboxIsMultiHit = 0
        o.oHitboxDamage = 2.5
        o.oHitboxHitstop = 3
    end,
    [HITBOX_MELEE_KUENZAN] = function(o)
        o.hitboxRadius            = 90 * sizeModifier
        o.hitboxHeight            = 166 * sizeModifier
        o.hitboxDownOffset        = 83 * sizeModifier
        o.oHitboxIsMultiHit = 1
        o.oHitboxDamage = 1
        o.oHitboxHitstop = 3
    end,
    [HITBOX_MELEE_SHIPPUGA] = function(o)
        o.hitboxRadius            = 100 * sizeModifier
        o.hitboxHeight            = 170 * sizeModifier
        o.hitboxDownOffset        = 90 * sizeModifier
        o.oHitboxIsMultiHit = 1
        o.oHitboxDamage = 2
        o.oHitboxHitstop = 3
    end,
    [HITBOX_MELEE_RAIKOUSEN] = function(o)
        o.hitboxRadius            = 70 * sizeModifier
        o.hitboxHeight            = 100 * sizeModifier
        o.hitboxDownOffset        = 50 * sizeModifier
        o.oHitboxIsMultiHit = 0
        o.oHitboxDamage = 6
        o.oHitboxHitstop = 3
    end,
    [HITBOX_MELEE_WALL_SLIDE_SLASH] = function(o)
        o.hitboxRadius            = 90 * sizeModifier
        o.hitboxHeight            = 120 * sizeModifier
        o.hitboxDownOffset        = 60 * sizeModifier
        o.oHitboxIsMultiHit = 0
        o.oHitboxDamage = 2.5
        o.oHitboxHitstop = 3
    end,
    [HITBOX_MELEE_HYOURETSUZAN] = function(o)
        o.hitboxRadius            = 90 * sizeModifier
        o.hitboxHeight            = 145 * sizeModifier
        o.hitboxDownOffset        = 80 * sizeModifier
        o.oHitboxIsMultiHit = 1
        o.oHitboxDamage = 1.4
        o.oHitboxHitstop = 3
    end,
    [HITBOX_MELEE_RYUENJIN] = function(o)
        o.hitboxRadius            = 112 * sizeModifier
        o.hitboxHeight            = 310 * sizeModifier
        o.hitboxDownOffset        = 245 * sizeModifier
        o.oHitboxIsMultiHit = 1
        o.oHitboxDamage = 2.2
        o.oHitboxHitstop = 3
    end,
    [HITBOX_MELEE_SENTSUIZAN] = function(o)
        o.hitboxRadius            = 100 * sizeModifier
        o.hitboxHeight            = 150 * sizeModifier
        o.hitboxDownOffset        = 80 * sizeModifier
        o.oHitboxIsMultiHit = 0
        o.oHitboxDamage = 7
        o.oHitboxHitstop = 3
    end,
}

local numberOfHitboxes = {
    [HITBOX_MELEE_LIGHT_SLASH] = 2,
    [HITBOX_MELEE_MEDIUM_SLASH] = 2,
    [HITBOX_MELEE_HEAVY_SLASH] = 3,
    [HITBOX_MELEE_AIR_SLASH] = 2,
    [HITBOX_MELEE_KUENZAN] = 3,
    [HITBOX_MELEE_SHIPPUGA] = 2,
    [HITBOX_MELEE_RAIKOUSEN] = 3,
    [HITBOX_MELEE_WALL_SLIDE_SLASH] = 2,
    [HITBOX_MELEE_HYOURETSUZAN] = 2,
    [HITBOX_MELEE_RYUENJIN] = 3,
    [HITBOX_MELEE_SENTSUIZAN] = 1
}

zSaberDeleteConditionTable = {
    [HITBOX_MELEE_LIGHT_SLASH] = function(m, timer)
        return m.action ~= ACT_LIGHT_ZSABER or timer == 12
    end,
    [HITBOX_MELEE_MEDIUM_SLASH] = function(m, timer)
        return m.action ~= ACT_MEDIUM_ZSABER or timer == 11
    end,
    [HITBOX_MELEE_HEAVY_SLASH] = function(m, timer)
        return m.action ~= ACT_HEAVY_ZSABER or timer == 12
    end,
    [HITBOX_MELEE_AIR_SLASH] = function(m, timer)
        local mmx = gMmxStates[m.playerIndex]
        return ((mmx.zero_cancel_slash == 1 and timer > 0) or
         (m.action ~= ACT_AIR_SLASH and m.action ~= ACT_AIR_SLASH_LAND)) or timer == 12
    end,
    [HITBOX_MELEE_KUENZAN] = function(m, timer)
        local mmx = gMmxStates[m.playerIndex]
        return (mmx.zero_cancel_slash == 1 and timer > 1) or m.action ~= ACT_KUENZAN or timer == 10
    end,
    [HITBOX_MELEE_SHIPPUGA] = function(m, timer)
        return m.action ~= ACT_SHIPPUGA or timer > 5
    end,
    [HITBOX_MELEE_RAIKOUSEN] = function(m, timer)
        return m.action ~= ACT_RAIKOUSEN
    end,
    [HITBOX_MELEE_WALL_SLIDE_SLASH] = function(m, timer)
        local mmx = gMmxStates[m.playerIndex]
        return (m.action ~= ACT_WALL_SLIDE or mmx.zero_wall_slide_slash == 0 
        or (mmx.zero_cancel_slash == 1 and timer > 1))
    end,
    [HITBOX_MELEE_HYOURETSUZAN] = function(m, timer)
        return m.action ~= ACT_HYOURETSUZAN
    end,
    [HITBOX_MELEE_RYUENJIN] = function(m, timer)
        return (m.action ~= ACT_RYUENJIN and m.action ~= ACT_RYUENJIN_START) or timer == 13
    end,
    [HITBOX_MELEE_SENTSUIZAN] = function(m, timer)
        return m.action ~= ACT_SENTSUIZAN
    end,
    [HITBOX_MELEE_RAIKOUSEN_LIGHTNING] = function(m, timer)
        return m.action ~= ACT_RAIKOUSEN or timer > 9
    end
}

local model_to_bz_model = {
    [E_model_lslash1] = E_model_lslash1_bz,
    [E_model_lslash2] = E_model_lslash2_bz,
    [E_model_lslash3] = E_model_lslash3_bz,
    [E_model_lslash4] = E_model_lslash4_bz,
    [E_model_lslash5] = E_model_lslash5_bz,
    [E_model_lslash6] = E_model_lslash6_bz,
    [E_model_lslash7] = E_model_lslash7_bz,
    [E_model_mslash2] = E_model_mslash2_bz,
    [E_model_mslash3] = E_model_mslash3_bz,
    [E_model_hslash1] = E_model_hslash1_bz,
    [E_model_hslash2] = E_model_hslash2_bz,
    [E_model_hslash3] = E_model_hslash3_bz,
    [E_model_hslash4] = E_model_hslash4_bz,
    [E_model_kuenzan] = E_model_kuenzan_bz,
    [E_model_kuenzan2] = E_model_kuenzan2_bz,
    [E_model_sentsuizan] = E_model_sentsuizan_bz,
}

local function set_saber_model_or_bz_model(o, model)
    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    if s.zero_alt ~= 1 or not model_to_bz_model[model] then
        return obj_set_model_extended(o, model)
    end
    return obj_set_model_extended(o, model_to_bz_model[model])
end

local saber_init = function(o)
    set_saber_model_or_bz_model(o, E_model_lslash1)
    --o.oMoveAnglePitch = o.oMoveAnglePitch - 38000
    --o.oMoveAngleYaw = o.oMoveAngleYaw + 1500

    spawn_non_sync_object(id_bhvZsaberBase, E_MODEL_NONE, o.oPosX, o.oPosY, o.oPosZ, function(obj)
        obj.parentObj = o
        obj.oHitboxType = o.oSaberIndex
        obj.oOwner = o.oOwner
    end)

    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]

    if o.oSaberIndex ~= HITBOX_MELEE_RAIKOUSEN then
        for i = 1, numberOfHitboxes[o.oSaberIndex] do
            spawn_non_sync_object(id_bhvHitbox, E_MODEL_NONE, o.oPosX, o.oPosY, o.oPosZ, function(obj)
                obj.parentObj = o
                obj.oHitboxType = o.oSaberIndex
                obj.oOwner = o.oOwner
                hitboxSpawnData[o.oSaberIndex](obj)
                obj.oHitboxPositionIndex = i
                obj.oFurthestHitbox = numberOfHitboxes[o.oSaberIndex]
                obj.oHitboxGlobalIndex = o.oHitboxGlobalIndex
                obj.oHitboxWaitTimesBetweenHits = 3
            end)
        end
    end
     
    cur_obj_hide()
    o.oFlags = (OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE | OBJ_FLAG_SET_FACE_ANGLE_TO_MOVE_ANGLE | OBJ_FLAG_SET_FACE_YAW_TO_MOVE_YAW)
    o.oMoveAngleYaw = m.faceAngle.y
    if o.oSaberIndex == HITBOX_MELEE_HEAVY_SLASH then
        o.oMoveAngleRoll = o.oMoveAngleRoll - 3000
    elseif o.oSaberIndex == HITBOX_MELEE_AIR_SLASH or o.oSaberIndex == HITBOX_MELEE_MEDIUM_SLASH then
        if o.oSaberIndex == HITBOX_MELEE_AIR_SLASH then
            o.oMoveAnglePitch = o.oMoveAnglePitch + 3000
        end
        o.oMoveAngleYaw = o.oMoveAngleYaw + 15000
    elseif o.oSaberIndex == HITBOX_MELEE_LIGHT_SLASH then
        o.oMoveAngleRoll = o.oMoveAngleRoll + 3000
    elseif o.oSaberIndex == HITBOX_MELEE_KUENZAN then
        o.oMoveAnglePitch = o.oMoveAnglePitch - 5000
    elseif o.oSaberIndex == HITBOX_MELEE_WALL_SLIDE_SLASH then
        o.oMoveAngleYaw = o.oMoveAngleYaw + 0x8000
    end
    set_hitbox_pos_and_angle_to_obj_pos_angle(o)
end

local saber_loop = function(o)
    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]
    local mmx = gMmxStates[m.playerIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    o.hookRender = true
    if s.mmx_hit_stop > 0 then
        o.oTimer = o.oTimer - 1
        return
    end

    local up = 0
    local front = 0
    local side = 0

    local replaceUp = 0
    local replaceFront = 0
    local replaceSide = 0
    local replaceYaw = 0
    local replacePitch = 0

    local limb = 0

    local replaceHitboxPos = false
    local replaceHitboxAngle = false
    
    -- you won't be ready for the code that follows

    if (o.oSaberIndex == HITBOX_MELEE_LIGHT_SLASH) then
        front = 13
        side = -10
        up = -15
        if (o.oTimer == 2) then
            o.oMoveAngleYaw = o.oMoveAngleYaw + 1500
            set_saber_model_or_bz_model(o, E_model_lslash1)
            o.oMoveAnglePitch = -20000
            o.oMoveAngleYaw = o.oMoveAngleYaw - 3000
            o.oMoveAngleRoll = o.oMoveAngleRoll - 3000
            obj_scale_xyz(o, 0.6, 1.1, 0.96)
            cur_obj_unhide()
        elseif (o.oTimer == 3) then
            set_saber_model_or_bz_model(o, E_model_lslash2)
            obj_scale_xyz(o, 1.15, 1.63, 0.95)
            o.oMoveAnglePitch = -7500
        elseif (o.oTimer == 4) then
            set_saber_model_or_bz_model(o, E_model_lslash6)
            o.oMoveAngleYaw = o.oMoveAngleYaw + 3000
            o.oMoveAngleRoll = o.oMoveAngleRoll + 3000
            obj_scale_xyz(o, 1, 1.33, 1)
            o.oMoveAnglePitch = -1000
        elseif (o.oTimer == 5) then
            local scaleRate = 1 - ((o.oTimer / 4) * 0.05)
            obj_scale_xyz(o, scaleRate, scaleRate * 0.6, scaleRate * 0.975)
            o.oMoveAnglePitch = 250
        elseif (o.oTimer > 5 and o.oTimer <= 7) then
            local scaleRate = 0.9 - ((o.oTimer / 5) * 0.1)
            obj_scale_xyz(o, scaleRate, scaleRate, scaleRate * 0.85)
            o.oMoveAnglePitch = 1200
            set_saber_model_or_bz_model(o, E_model_lslash3)
        elseif (o.oTimer > 7) then
            local scaleRate = 0.8 - ((o.oTimer / 4) * 0.1)
            obj_scale_xyz(o, scaleRate, scaleRate, scaleRate * 0.9)
            o.oMoveAnglePitch = 1600
            set_saber_model_or_bz_model(o, E_model_lslash4)
        end
        if (m.action ~= ACT_LIGHT_ZSABER or o.oTimer == 12) then
            obj_mark_for_deletion(o)
        end
    elseif (o.oSaberIndex == HITBOX_MELEE_MEDIUM_SLASH) then
        front = 0
        side = 20
        up = -5
        if (o.oTimer == 2) then
            front = -30
            side = 25
            up = -5
            replaceFront = -20
            replaceSide = -10
            replaceUp = -5
            replaceHitboxPos = true
            o.oMoveAngleYaw = o.oMoveAngleYaw - 5500
            set_saber_model_or_bz_model(o, E_model_hslash1)
            obj_scale_xyz(o, 1.48, 0.6, 1.28)
            cur_obj_unhide()
            replaceYaw = o.oMoveAngleYaw - 1000
            replaceHitboxAngle = true
        elseif (o.oTimer == 3) then
            obj_scale_xyz(o, 1.45, 0.7, 1.85)
            o.oMoveAngleYaw = o.oMoveAngleYaw - 15500
            side = -70
            front = -60
            replaceFront = 0
            replaceSide = 20
            replaceUp = -5
            replaceYaw = o.oMoveAngleYaw + 7500
            replacePitch = o.oMoveAnglePitch
            replaceHitboxPos = true
            replaceHitboxAngle = true
        elseif (o.oTimer == 4) then
            set_saber_model_or_bz_model(o, E_model_hslash2)
            obj_scale_xyz(o, 1.2, 0.75, 1.5)
            o.oMoveAngleYaw = o.oMoveAngleYaw - 4500
            replaceYaw = o.oMoveAngleYaw + 1000
            replaceHitboxAngle = true
        elseif (o.oTimer == 5) then
            local scaleRate = 1 - ((o.oTimer / 4) * 0.05)
            obj_scale_xyz(o, scaleRate * 0.6, scaleRate * 0.75, scaleRate * 0.975)
            o.oMoveAngleYaw = o.oMoveAngleYaw - 1500
            replaceYaw = o.oMoveAngleYaw + 1000
            replaceHitboxAngle = true
        elseif (o.oTimer > 5 and o.oTimer <= 7) then
            local scaleRate = 0.9 - ((o.oTimer / 5) * 0.1)
            obj_scale_xyz(o, scaleRate , scaleRate, scaleRate * 0.95)
            set_saber_model_or_bz_model(o, E_model_hslash3)
            replaceYaw = o.oMoveAngleYaw + 1000
            replaceHitboxAngle = true
        elseif (o.oTimer > 7) then
            local scaleRate = 0.8 - ((o.oTimer / 4) * 0.1)
            obj_scale_xyz(o, scaleRate , scaleRate, scaleRate * 0.9)
            set_saber_model_or_bz_model(o, E_model_hslash4)
            replaceYaw = o.oMoveAngleYaw + 1000
            replaceHitboxAngle = true
        end
        if (m.action ~= ACT_MEDIUM_ZSABER or o.oTimer == 11) then
            obj_mark_for_deletion(o)
        end
    elseif (o.oSaberIndex == HITBOX_MELEE_HEAVY_SLASH) then
        front = 13
        side = 10
        up = -10
        if (o.oTimer == 2) then
            o.oMoveAngleYaw = o.oMoveAngleYaw + 1500
            front = 14
            o.oMoveAngleRoll = o.oMoveAngleRoll + 8000
            o.oMoveAngleYaw = o.oMoveAngleYaw - 5000
            set_saber_model_or_bz_model(o, E_model_lslash5)
            obj_scale_xyz(o, 1.2, 1.3, 1.1)
            o.oMoveAnglePitch = -19000
            cur_obj_unhide()
        elseif (o.oTimer == 3) then
            o.oMoveAngleRoll = o.oMoveAngleRoll - 8000
            o.oMoveAngleYaw = o.oMoveAngleYaw + 5000
            set_saber_model_or_bz_model(o, E_model_lslash5)
            obj_scale_xyz(o, 1.2, 1.68, 1.65)
            o.oMoveAnglePitch = -10000
        elseif (o.oTimer == 4) then
            set_saber_model_or_bz_model(o, E_model_lslash7)
            obj_scale_xyz(o, 1, 1.54, 1.48)
            o.oMoveAnglePitch = -3000
        elseif (o.oTimer == 5) then
            local scaleRate = 1.1 - ((o.oTimer / 4) * 0.05)
            obj_scale_xyz(o, scaleRate, 0.93, 1.2)
            o.oMoveAnglePitch = 0
            set_saber_model_or_bz_model(o, E_model_lslash6)
        elseif (o.oTimer > 5 and o.oTimer <= 7) then
            local scaleRate = 0.9 - ((o.oTimer / 5) * 0.1)
            obj_scale_xyz(o, scaleRate, scaleRate, scaleRate * 0.95)
            set_saber_model_or_bz_model(o, E_model_lslash3)
        elseif (o.oTimer > 7) then
            local scaleRate = 0.8 - ((o.oTimer / 4) * 0.1)
            obj_scale_xyz(o, scaleRate, scaleRate, scaleRate * 0.9)
            o.oMoveAnglePitch = 1000
            set_saber_model_or_bz_model(o, E_model_lslash4)
        end
        if (m.action ~= ACT_HEAVY_ZSABER or o.oTimer == 12) then
            obj_mark_for_deletion(o)
        end
    elseif (o.oSaberIndex == HITBOX_MELEE_AIR_SLASH) then
        front = 0
        side = 20
        up = 0
        if (o.oTimer == 2) then
            o.oMoveAngleYaw = o.oMoveAngleYaw + 1500
            set_saber_model_or_bz_model(o, E_model_hslash1)
            obj_scale_xyz(o, 1.3, 0.6, 1.3)
            front = 45
            side = 30
            up = -20
            replaceFront = 0
            replaceSide = 20
            replaceUp = 0
            replaceHitboxPos = true
            cur_obj_unhide()
            o.oMoveAngleYaw = o.oMoveAngleYaw - 6000
            replaceYaw = o.oMoveAngleYaw - 6000
            replacePitch = o.oMoveAnglePitch
            replaceHitboxAngle = true
        elseif (o.oTimer == 3) then
            front = -50
            up = -7
            replaceFront = 0
            replaceSide = 20
            replaceUp = 0
            replaceHitboxPos = true
            obj_scale_xyz(o, 1.5, 0.7, 1.5)
            o.oMoveAngleYaw = o.oMoveAngleYaw - 8500
            replaceYaw = o.oMoveAngleYaw - 4000
            replacePitch = o.oMoveAnglePitch
            replaceHitboxAngle = true
        elseif (o.oTimer == 4) then
            set_saber_model_or_bz_model(o, E_model_hslash2)
            obj_scale_xyz(o, 1.15, 0.7, 1.25)
            o.oMoveAngleYaw = o.oMoveAngleYaw - 7000
            replaceYaw = o.oMoveAngleYaw - 4000
            replacePitch = o.oMoveAnglePitch
            replaceHitboxAngle = true
        elseif (o.oTimer == 5) then
            local scaleRate = 1 - ((o.oTimer / 4) * 0.05)
            obj_scale_xyz(o, scaleRate * 0.6, scaleRate * 0.7, scaleRate * 0.975)
            o.oMoveAngleYaw = o.oMoveAngleYaw - 1000
            replaceYaw = o.oMoveAngleYaw - 3000
            replacePitch = o.oMoveAnglePitch
            replaceHitboxAngle = true
        elseif (o.oTimer > 5 and o.oTimer <= 7) then
            local scaleRate = 0.9 - ((o.oTimer / 5) * 0.1)
            obj_scale_xyz(o, scaleRate , scaleRate * 0.9, scaleRate * 0.95)
            set_saber_model_or_bz_model(o, E_model_hslash3)
            replaceYaw = o.oMoveAngleYaw - 2000
            replacePitch = o.oMoveAnglePitch
            replaceHitboxAngle = true
        elseif (o.oTimer > 7) then
            local scaleRate = 0.8 - ((o.oTimer / 4) * 0.1)
            obj_scale_xyz(o, scaleRate , scaleRate * 0.9, scaleRate * 0.9)
            set_saber_model_or_bz_model(o, E_model_hslash4)
            replaceYaw = o.oMoveAngleYaw - 1000
            replacePitch = o.oMoveAnglePitch
            replaceHitboxAngle = true
        end
        local mmx = gMmxStates[m.playerIndex]
        if ((mmx.zero_cancel_slash == 1 and o.oTimer > 0) or (m.action ~= ACT_AIR_SLASH and m.action ~= ACT_AIR_SLASH_LAND))
        or o.oTimer == 12 then
            obj_mark_for_deletion(o)
        end
    elseif (o.oSaberIndex == HITBOX_MELEE_KUENZAN) then
        front = 10
        side = -10
        up = 1
        if (o.oTimer == 1) then
            cur_obj_unhide()
            set_saber_model_or_bz_model(o, E_model_kuenzan2)
            obj_scale_xyz(o, 1.8, 1.06, 1.57)
        elseif (o.oTimer == 2) then
            set_saber_model_or_bz_model(o, E_model_kuenzan)
        elseif (o.oTimer == 3) then
            obj_scale_xyz(o, 1.8, 1.52, 1.59)
        elseif (o.oTimer == 6) then
            obj_scale_xyz(o, 1.8, 1.56, 1.56)
        elseif (o.oTimer == 8) then
            set_saber_model_or_bz_model(o, E_model_kuenzan2)
            obj_scale_xyz(o, 1.8, 1.19, 1.24)
        end

        o.oMoveAnglePitch = o.oMoveAnglePitch + 10000 - (o.oTimer * 300)
        local mmx = gMmxStates[m.playerIndex]
        if ((mmx.zero_cancel_slash == 1 and o.oTimer > 1) or m.action ~= ACT_KUENZAN or o.oTimer == 10) then
            obj_mark_for_deletion(o)
        end
    elseif (o.oSaberIndex == HITBOX_MELEE_SHIPPUGA) then
        limb = 1
        side = 15
        up = 10
        front = -5
        if (o.oTimer == 1) then
            o.oMoveAngleYaw = o.oMoveAngleYaw + 1500
            set_saber_model_or_bz_model(o, E_model_shippuga)
            obj_scale_xyz(o, 0.7, 0.7, 1.1)
            cur_obj_unhide()
            --o.oMoveAnglePitch = 4000
            o.oMoveAngleRoll = 5000
            --o.oMoveAngleYaw = o.oMoveAngleYaw - 5000
        elseif (o.oTimer > 2 and o.oTimer < 7) then
            local scaleRate = (o.oTimer % 2) * 0.1
            obj_scale_xyz(o, 0.6 + scaleRate, 1 + scaleRate, 0.7 + scaleRate)
            --o.oMoveAnglePitch = o.oMoveAnglePitch + 600
            
        else
            obj_scale_xyz(o, 0.35, 0.6, 0.6)
        end
        if (m.action ~= ACT_SHIPPUGA or o.oTimer == 8) then
            obj_mark_for_deletion(o)
        end
    elseif (o.oSaberIndex == HITBOX_MELEE_RAIKOUSEN) then
        if (o.oTimer == 1) then
            o.oMoveAngleYaw = o.oMoveAngleYaw + 3000
            up = -21
            front = 20
            side = -2
            obj_scale(o, 1 - 13 * 0.05)
            set_saber_model_or_bz_model(o, E_model_raikousen_blade)
            cur_obj_unhide()
            o.oMoveAnglePitch = 3500
            o.oMoveAngleRoll = 5000
            o.oMoveAngleYaw = o.oMoveAngleYaw - 5000
        elseif o.oTimer < 12 then
            up = -21
            front = 20
            side = -2
            obj_scale(o, 1 - (14 - o.oTimer) * 0.05)
        elseif (o.oTimer == 12) then
            for i = 1, numberOfHitboxes[o.oSaberIndex] do
                spawn_non_sync_object(id_bhvHitbox, E_MODEL_NONE, o.oPosX, o.oPosY, o.oPosZ, function(obj)
                    obj.parentObj = o
                    obj.oHitboxType = o.oSaberIndex
                    obj.oOwner = o.oOwner
                    hitboxSpawnData[o.oSaberIndex](obj)
                    obj.oHitboxPositionIndex = i
                    obj.oFurthestHitbox = numberOfHitboxes[o.oSaberIndex]
                    obj.oHitboxGlobalIndex = o.oHitboxGlobalIndex
                    obj.oHitboxWaitTimesBetweenHits = 3
                end)
            end
            o.oMoveAngleYaw = o.oMoveAngleYaw - 3000
            cur_obj_hide()
        elseif (o.oTimer == 21) then
            front = 35
            cur_obj_unhide()
            obj_scale(o, 1)
            o.oMoveAnglePitch = 0
            o.oMoveAngleRoll = 0
            o.oMoveAngleYaw = o.oMoveAngleYaw + 5000
        elseif (o.oTimer > 21 and o.oTimer <= 29) then
            front = 35
        elseif (o.oTimer > 29) then
            obj_scale(o, 1 - (o.oTimer - 30) * 0.045)
        end
        if (m.action ~= ACT_RAIKOUSEN) then
            obj_mark_for_deletion(o)
        end
    elseif o.oSaberIndex == HITBOX_MELEE_WALL_SLIDE_SLASH then
        limb = 1
        up = -15
        front = -15
        if (o.oTimer == 2) then
            o.oMoveAnglePitch = -20000
            obj_scale(o, 0.6)
            o.header.gfx.scale.z = 1.2
            o.header.gfx.scale.y = 1.15
        elseif (o.oTimer == 3) then
            cur_obj_unhide()
            set_saber_model_or_bz_model(o, E_model_lslash2)
            obj_scale_xyz(o, 1.2, 1.8, 1.2)
            o.oMoveAnglePitch = -8000
        elseif (o.oTimer == 4) then
            obj_scale_xyz(o, 1.2, 1.65, 1.2)
            o.oMoveAnglePitch = -1000
        elseif (o.oTimer == 5) then
            local scaleRate = 1.1 - ((o.oTimer / 4) * 0.05)
            obj_scale_xyz(o, scaleRate, 0.6, scaleRate * 0.95)
            o.oMoveAnglePitch = o.oTimer * 50
        elseif (o.oTimer > 5 and o.oTimer < 7) then
            local scaleRate = 0.9 - ((o.oTimer / 5) * 0.1)
            obj_scale_xyz(o, scaleRate, 0.6, scaleRate * 0.95)
            set_saber_model_or_bz_model(o, E_model_lslash3)
        elseif o.oTimer >= 7 then
            obj_scale_xyz(o, 0.6, 0.6, 0.6)
            o.oMoveAnglePitch = o.oMoveAnglePitch + 500
            set_saber_model_or_bz_model(o, E_model_lslash4)
        end
        if (m.action ~= ACT_WALL_SLIDE or mmx.zero_wall_slide_slash == 0 
        or (mmx.zero_cancel_slash == 1 and o.oTimer > 1)) then
            obj_mark_for_deletion(o)
        end
    elseif o.oSaberIndex == HITBOX_MELEE_HYOURETSUZAN then
        side = -10
        if (o.oTimer == 1) then
            set_saber_model_or_bz_model(o, E_model_hyouretsuzan)
            cur_obj_unhide()
            obj_scale(o, 0.5)
            front = 30
        elseif o.oTimer == 2 then
            obj_scale_xyz(o, 0.7, 0.7, 0.85)
            front = 15
        elseif o.oTimer == 3 then
            obj_scale_xyz(o, 0.9, 0.9, 1)
        end
        o.oMoveAnglePitch = 16384
        if (m.action ~= ACT_HYOURETSUZAN) then
            obj_mark_for_deletion(o)
        end
    elseif o.oSaberIndex == HITBOX_MELEE_RYUENJIN then
        up = 27
        if o.oTimer == 1 then
            cur_obj_unhide()
            obj_scale_xyz(o, 0.92, 0.7, 0.92)
            front = 50
        elseif o.oTimer == 3 then
            o.oMoveAnglePitch = -4000
            obj_scale_xyz(o, 0.92, 0.92, 0.92)
        elseif o.oTimer == 11 then
            obj_scale_xyz(o, 0.92, 0.52, 0.82)
        end
    
        if (o.oTimer % 2 == 0) then
            set_saber_model_or_bz_model(o, E_model_ryuenjin2)
        else
            set_saber_model_or_bz_model(o, E_model_ryuenjin1)
        end

        local xOffsetByPlayerSpeed = 0
        local yOffsetByPlayerSpeed = 0
        local zOffsetByPlayerSpeed = 0
        if o.oTimer < 13 then
            xOffsetByPlayerSpeed = mmx.dPrevPos.x - m.vel.x
            yOffsetByPlayerSpeed = mmx.dPrevPos.y - m.vel.y - 4
            zOffsetByPlayerSpeed = mmx.dPrevPos.z - m.vel.z
        end
    
        if (o.oTimer < 12 and o.oTimer > 1) then
            local timeroffset = (o.oTimer - 2) * -15
                spawn_non_sync_object(id_bhvRotatedFlame, E_MODEL_RED_FLAME, 
                o.oPosX + sins(o.oMoveAngleYaw) * (230 + timeroffset) + xOffsetByPlayerSpeed, 
                o.oPosY - 20 + yOffsetByPlayerSpeed, 
                o.oPosZ + coss(o.oMoveAngleYaw) * (230 + timeroffset) + zOffsetByPlayerSpeed, function(obj)
                    obj.header.gfx.scale.x = 4
                    obj.header.gfx.scale.y = 4
                    obj.header.gfx.scale.z = 4
                    obj.oOwner = o.oOwner
                end)
            
            if (o.oTimer < 10) then
                local evenOffset = 0
                if (o.oTimer % 2 == 0) then
                    evenOffset = 50
                end
                spawn_non_sync_object(id_bhvRotatedFlame, E_MODEL_BOWSER_FLAMES, 
                o.oPosX + sins(o.oMoveAngleYaw) * (260 + timeroffset - evenOffset) + xOffsetByPlayerSpeed, 
                o.oPosY + 110 + yOffsetByPlayerSpeed, 
                o.oPosZ + coss(o.oMoveAngleYaw) * (260 + timeroffset - evenOffset) + zOffsetByPlayerSpeed, function(obj)
                    obj.header.gfx.scale.x = 0.55
                    obj.header.gfx.scale.y = 0.55
                    obj.header.gfx.scale.z = 0.55
                    obj.oMoveAngleRoll = 32768
                    obj.oOwner = o.oOwner
                end)


                spawn_non_sync_object(id_bhvRotatedFlame, E_MODEL_BOWSER_FLAMES, 
                o.oPosX + sins(o.oMoveAngleYaw) * (320 + timeroffset - evenOffset) + xOffsetByPlayerSpeed, 
                o.oPosY + 80 + yOffsetByPlayerSpeed, 
                o.oPosZ + coss(o.oMoveAngleYaw) * (320 + timeroffset - evenOffset) + zOffsetByPlayerSpeed, function(obj)
                    obj.header.gfx.scale.x = 0.6
                    obj.header.gfx.scale.y = 0.6
                    obj.header.gfx.scale.z = 0.6
                    obj.oMoveAngleRoll = 32768
                    obj.oOwner = o.oOwner
                end)
        
                spawn_non_sync_object(id_bhvRotatedFlame, E_MODEL_BOWSER_FLAMES, 
                o.oPosX + sins(o.oMoveAngleYaw) * (320 + timeroffset - evenOffset) + xOffsetByPlayerSpeed, 
                o.oPosY + 80 + yOffsetByPlayerSpeed, 
                o.oPosZ + coss(o.oMoveAngleYaw) * (320 + timeroffset - evenOffset) + zOffsetByPlayerSpeed, function(obj)
                    obj.header.gfx.scale.x = 0.6
                    obj.header.gfx.scale.y = 0.2
                    obj.header.gfx.scale.z = 0.6
                    obj.oOwner = o.oOwner
                end)
    
                if (o.oTimer == 9) then
                    spawn_non_sync_object(id_bhvRotatedFlame, E_MODEL_BOWSER_FLAMES, 
                    o.oPosX + sins(o.oMoveAngleYaw) * (340 + timeroffset - evenOffset) + xOffsetByPlayerSpeed, 
                    o.oPosY + 130 + yOffsetByPlayerSpeed, 
                    o.oPosZ + coss(o.oMoveAngleYaw) * (340 + timeroffset - evenOffset) + zOffsetByPlayerSpeed, function(obj)
                        obj.header.gfx.scale.x = 0.4
                        obj.header.gfx.scale.y = 0.6
                        obj.header.gfx.scale.z = 0.4
                        obj.oMoveAngleRoll = 32768
                        obj.oOwner = o.oOwner
                    end)
            
                    spawn_non_sync_object(id_bhvRotatedFlame, E_MODEL_BOWSER_FLAMES, 
                    o.oPosX + sins(o.oMoveAngleYaw) * (340 + timeroffset - evenOffset) + xOffsetByPlayerSpeed, 
                    o.oPosY + 130 + yOffsetByPlayerSpeed, 
                    o.oPosZ + coss(o.oMoveAngleYaw) * (340 + timeroffset - evenOffset) + zOffsetByPlayerSpeed, function(obj)
                        obj.header.gfx.scale.x = 0.4
                        obj.header.gfx.scale.y = 0.2
                        obj.header.gfx.scale.z = 0.4
                        obj.oOwner = o.oOwner
                    end)
                end
            end
        
            spawn_non_sync_object(id_bhvWhitePuffSmoke2, E_MODEL_RED_FLAME, 
            o.oPosX + sins(o.oMoveAngleYaw) * (240 + timeroffset) + xOffsetByPlayerSpeed, 
            o.oPosY - 60 + yOffsetByPlayerSpeed, 
            o.oPosZ + coss(o.oMoveAngleYaw) * (240 + timeroffset) + zOffsetByPlayerSpeed, function(obj)
                obj.header.gfx.scale.x = 3
                obj.header.gfx.scale.y = 3
                obj.header.gfx.scale.z = 3
            end)
        
            if (o.oTimer >= 5) then
                spawn_non_sync_object(id_bhvWhitePuffSmoke2, E_MODEL_RED_FLAME, 
                o.oPosX + sins(o.oMoveAngleYaw) * (295 + timeroffset * 1.1) + xOffsetByPlayerSpeed, 
                o.oPosY - 70 + yOffsetByPlayerSpeed, 
                o.oPosZ + coss(o.oMoveAngleYaw) * (295 + timeroffset * 1.1) + zOffsetByPlayerSpeed, function(obj)
                    obj.header.gfx.scale.x = 2.5
                    obj.header.gfx.scale.y = 2.5
                    obj.header.gfx.scale.z = 2.5
                end)
            end
        
            if (o.oTimer >= 7) then
                spawn_non_sync_object(id_bhvWhitePuffSmoke2, E_MODEL_RED_FLAME, 
                o.oPosX + sins(o.oMoveAngleYaw) * 170 + xOffsetByPlayerSpeed,
                o.oPosY - 50 + yOffsetByPlayerSpeed,
                o.oPosZ + coss(o.oMoveAngleYaw) * 170 + zOffsetByPlayerSpeed, function(obj)
                    obj.header.gfx.scale.x = 2.5
                    obj.header.gfx.scale.y = 2.5
                    obj.header.gfx.scale.z = 2.5
                end)
            end
        end
        if (m.action ~= ACT_RYUENJIN and m.action ~= ACT_RYUENJIN_START) or o.oTimer == 13 then
            obj_mark_for_deletion(o)
        end
    elseif o.oSaberIndex == HITBOX_MELEE_SENTSUIZAN then
        front = 32
        up = -25
        side = -15
        if (o.oTimer == 1) then
            set_saber_model_or_bz_model(o, E_model_sentsuizan)
            o.oMoveAnglePitch = 5000
            o.oMoveAngleRoll = 5000
            obj_scale_xyz(o, 0.6, 1, 0.9)
            cur_obj_unhide()
        end
        if (m.action ~= ACT_SENTSUIZAN) then
            obj_mark_for_deletion(o)
        end
    end
    if replaceHitboxPos == true then
        move_hitboxpos_to_limb(o, limb, replaceUp, replaceSide, replaceFront)
    end
    move_object_to_limb(o, limb, up, side, front)
    if replaceHitboxPos == false then
        o.oHitboxPosX = o.oPosX
        o.oHitboxPosY = o.oPosY
        o.oHitboxPosZ = o.oPosZ
    end
    if replaceHitboxAngle == true then
        o.oHitboxYaw = replaceYaw
        o.oHitboxPitch = replacePitch
    else
        o.oHitboxYaw = o.oMoveAngleYaw
        o.oHitboxPitch = o.oMoveAnglePitch
    end
end


-- Hyouretsuzan saber
local hyouretsuzan_shard_init = function(o)
    obj_set_model_extended(o, E_model_hyouretsuzan_shard)
    obj_scale(o, 0.45)
    o.oFlags = (OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE | OBJ_FLAG_SET_FACE_ANGLE_TO_MOVE_ANGLE | OBJ_FLAG_SET_FACE_YAW_TO_MOVE_YAW)
end

local hyouretsuzan_shard_loop = function(o)
    local vspeed = 27 - o.oTimer * 3.9
    o.oPosX = o.oPosX + sins(o.oMoveAngleYaw) * 10
    o.oPosY = o.oPosY + vspeed
    o.oPosZ = o.oPosZ + coss(o.oMoveAngleYaw) * 10
    o.oMoveAnglePitch = o.oMoveAnglePitch + 5500
    if o.oTimer > 11 and o.oTimer < 14 then
        obj_scale(o, 0.35)
    elseif o.oTimer >= 14 then
        obj_mark_for_deletion(o)
    end
end


local rotated_flame_init = function(o)
    o.oFlags = (OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE | OBJ_FLAG_SET_FACE_ANGLE_TO_MOVE_ANGLE | OBJ_FLAG_SET_FACE_YAW_TO_MOVE_YAW)
    o.oAnimState = 4
    cur_obj_hide()
end

local rotated_flame_loop = function(o)
    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    if (s.mmx_hit_stop > 0) then
        o.oTimer = o.oTimer - 1
        return
    end
    if (o.oTimer == 1) then
        cur_obj_unhide()
    end
    local m0 = gMarioStates[0]
    o.oMoveAngleYaw = m0.area.camera.yaw
    o.oAnimState = o.oAnimState + 1

    local pitch = calculate_pitch(m0.pos, m0.area.camera.pos)
    o.oMoveAnglePitch = -pitch

    if o.oTimer == 4 then
        obj_mark_for_deletion(o)
    end
end


--- Raikousen lightning 
local raik_lightning_init = function(o)
    obj_set_model_extended(o, E_model_raikousen)
    o.oFlags = (OBJ_FLAG_COMPUTE_ANGLE_TO_MARIO | OBJ_FLAG_COMPUTE_DIST_TO_MARIO | OBJ_FLAG_SET_FACE_ANGLE_TO_MOVE_ANGLE | OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE)
    o.header.gfx.scale.x = 1.2
    o.header.gfx.scale.y = 1.1
    o.header.gfx.scale.z = 1.2
    o.header.gfx.skipInViewCheck = true
    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]
    local mmx = gMmxStates[m.playerIndex]
    pitch = calculate_pitch(m.pos, mmx.zero_raikousen_start_pos)
    o.oMoveAnglePitch = pitch
    o.oMoveAngleYaw = atan2s(m.pos.z - mmx.zero_raikousen_start_pos.z, m.pos.x - mmx.zero_raikousen_start_pos.x)
    o.oPosY = o.oPosY - (m.pos.y - mmx.zero_raikousen_start_pos.y)
    cur_obj_hide()
end

local raik_lightning_loop = function(o)
    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    if (s.mmx_hit_stop > 0) then
        o.oTimer = o.oTimer - 1
        return
    end
    if o.oTimer == 1 then
        cur_obj_unhide()
        
        local xpos = o.oPosX - sins(o.oMoveAngleYaw) * 780 * coss(o.oMoveAnglePitch)
        local ypos = o.oPosY
        local zpos = o.oPosZ - coss(o.oMoveAngleYaw) * 780 * coss(o.oMoveAnglePitch)
        spawn_non_sync_object(id_bhvRaikousenLightningHitboxSpawner, E_MODEL_NONE, xpos, ypos, zpos, function(obj)
            obj.oOwner = o.oOwner
            obj.oMoveAngleYaw = o.oMoveAngleYaw
            obj.oMoveAnglePitch = o.oMoveAnglePitch
            obj.oHitboxGlobalIndex = o.oHitboxGlobalIndex
        end)
    end
    o.hookRender = true

    local timer = o.oTimer
    local scale_x, scale_y

    if timer == 3 then
        scale_x, scale_y = 1.75, 1.65
    elseif timer == 7 then
        scale_x, scale_y = 0.95, 0.85
        o.oMoveAngleRoll = o.oMoveAngleRoll + 16384
    elseif timer == 8 then
        scale_x, scale_y = 0.85, 0.75
    elseif timer % 2 == 0 then
        scale_x, scale_y = 1.45, 1.35
    else
        scale_x, scale_y = 1.2, 1.1
    end

    o.header.gfx.scale.x = scale_x
    o.header.gfx.scale.y = scale_y


    if timer == 3 or timer == 8 then
        obj_set_model_extended(o, E_model_raikousen2)
    elseif timer == 5 then
        obj_set_model_extended(o, E_model_raikousen)
    elseif timer == 9 then
        obj_mark_for_deletion(o)
    end
end


local lightning_hitbox_spawner_init = function(o)
    obj_set_model_extended(o, E_model_raikousen)
    o.oFlags = (OBJ_FLAG_COMPUTE_ANGLE_TO_MARIO | OBJ_FLAG_COMPUTE_DIST_TO_MARIO | OBJ_FLAG_SET_FACE_ANGLE_TO_MOVE_ANGLE | OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE)
    cur_obj_hide()
    for i = 1, 6 do
        spawn_non_sync_object(id_bhvHitbox, E_MODEL_NONE, o.oPosX, o.oPosY, o.oPosZ, function(obj)
            obj.parentObj = o
            obj.oHitboxType = HITBOX_MELEE_RAIKOUSEN_LIGHTNING
            obj.oOwner = o.oOwner
            obj.oHitboxPositionIndex = i
            obj.oFurthestHitbox = 6
            obj.hitboxRadius            = 110
            obj.hitboxHeight            = 220
            obj.hitboxDownOffset        = 110
            obj.oHitboxIsMultiHit = 0
            obj.oHitboxDamage = 3.5
            obj.oHitboxGlobalIndex = o.oHitboxGlobalIndex
        end)
    end
    set_hitbox_pos_and_angle_to_obj_pos_angle(o)
end

local lightning_hitbox_spawner_loop = function(o)
    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    if (s.mmx_hit_stop > 0) then
        o.oTimer = o.oTimer - 1
        return
    end

    if o.oTimer == 10 then
        obj_mark_for_deletion(o)
    end
    set_hitbox_pos_and_angle_to_obj_pos_angle(o)
end



local zsaber_base_init = function(o)
    obj_set_model_extended(o, E_model_zsaber_base)
    o.oFlags = (OBJ_FLAG_COMPUTE_ANGLE_TO_MARIO | OBJ_FLAG_SET_FACE_ANGLE_TO_MOVE_ANGLE | OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE)
    cur_obj_hide()
    obj_scale(o, 0.5)
end

local zsaber_base_loop = function(o)
    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    if (s.mmx_hit_stop > 0) then
        o.oTimer = o.oTimer - 1
        return
    end
    if (o.oTimer == 2) then
        cur_obj_unhide()
    end
    o.oPosX = o.parentObj.oPosX
    o.oPosY = o.parentObj.oPosY
    o.oPosZ = o.parentObj.oPosZ
    
    o.oMoveAngleRoll = o.parentObj.oMoveAngleRoll
    if o.parentObj.oSaberIndex == HITBOX_MELEE_SHIPPUGA then
        o.oMoveAngleYaw = o.parentObj.oMoveAngleYaw - 5000
        o.oMoveAnglePitch = o.parentObj.oMoveAnglePitch + 4000
    else
        o.oMoveAngleYaw = o.parentObj.oMoveAngleYaw
        o.oMoveAnglePitch = o.parentObj.oMoveAnglePitch
    end
    
    if (zSaberDeleteConditionTable[o.oHitboxType](m, o.oTimer) ~= false) then
        obj_mark_for_deletion(o)
    end
    if (m.action == ACT_RAIKOUSEN) then
        if o.oTimer == 13 then
            cur_obj_hide()
        elseif o.oTimer == 22 then
            cur_obj_unhide()
        end
    end
end


--------------------------------------------------
--- REGISTRING BEHAVIORS -------------------------
--------------------------------------------------

id_bhvSaber = hook_behavior(nil, OBJ_LIST_UNIMPORTANT, false, saber_init, saber_loop)

id_bhvHyouretsuzanShard = hook_behavior(nil, OBJ_LIST_UNIMPORTANT, false, hyouretsuzan_shard_init, hyouretsuzan_shard_loop)

id_bhvRotatedFlame = hook_behavior(nil, OBJ_LIST_UNIMPORTANT, false, rotated_flame_init, rotated_flame_loop)

id_bhvRaikousenLightning = hook_behavior(nil, OBJ_LIST_UNIMPORTANT, false, raik_lightning_init, raik_lightning_loop)
id_bhvRaikousenLightningHitboxSpawner = hook_behavior(nil, OBJ_LIST_UNIMPORTANT, false, lightning_hitbox_spawner_init, lightning_hitbox_spawner_loop)
id_bhvZsaberBase = hook_behavior(nil, OBJ_LIST_UNIMPORTANT, false, zsaber_base_init, zsaber_base_loop)


--------------------------------------------------
--- RENDER SABERS --------------------------------
--------------------------------------------------


local sabers_table = {
    [E_model_lslash1] = true,
    [E_model_lslash2] = true,
    [E_model_lslash3] = true,
    [E_model_lslash4] = true,
    [E_model_lslash5] = true,
    [E_model_lslash6] = true,
    [E_model_lslash7] = true,
    [E_model_mslash2] = true,
    [E_model_mslash3] = true,
    [E_model_hslash1] = true,
    [E_model_hslash2] = true,
    [E_model_hslash3] = true,
    [E_model_hslash4] = true,
    [E_model_kuenzan] = true,
    [E_model_kuenzan2] = true,
    [E_model_sentsuizan] = true,
    [E_model_ryuenjin1] = true,
    [E_model_ryuenjin2] = true,
    [E_model_raikousen_blade] = true,
    [E_model_shippuga] = true,
}

local bz_sabers_table = {
    [E_model_lslash1_bz] = true,
    [E_model_lslash2_bz] = true,
    [E_model_lslash3_bz] = true,
    [E_model_lslash4_bz] = true,
    [E_model_lslash5_bz] = true,
    [E_model_lslash6_bz] = true,
    [E_model_lslash7_bz] = true,
    [E_model_mslash2_bz] = true,
    [E_model_mslash3_bz] = true,
    [E_model_hslash1_bz] = true,
    [E_model_hslash2_bz] = true,
    [E_model_hslash3_bz] = true,
    [E_model_hslash4_bz] = true,
    [E_model_kuenzan_bz] = true,
    [E_model_kuenzan2_bz] = true,
    [E_model_sentsuizan_bz] = true,
}

hook_event(HOOK_ON_OBJECT_RENDER, function(o)
    if o ~= nil and o.behavior ~= nil then
        if obj_get_model_id_extended(o) == E_model_raikousen or obj_get_model_id_extended(o) == E_model_raikousen2 then
            o.header.gfx.pos.x = o.oPosX - sins(o.oMoveAngleYaw) * 675
            o.header.gfx.pos.z = o.oPosZ - coss(o.oMoveAngleYaw) * 675
            local dl = cast_graph_node(o.header.gfx.sharedChild.children)
            
            gfx_parse(dl.displayList, function(cmd, op)
                if op == G_SETPRIMCOLOR then
                    gfx_set_command(cmd, "gsDPSetPrimColor", 255, 255, 255, 255, 255, 255)
                end 
                if op == G_SETCOMBINE then
                    gfx_set_combine_lerp(cmd, G_CCMUX_PRIMITIVE, 0, G_CCMUX_ENVIRONMENT, 0, G_ACMUX_1, 0, G_CCMUX_TEXEL0, 0, G_CCMUX_PRIMITIVE, 0, G_CCMUX_ENVIRONMENT, 0, G_ACMUX_1, 0, G_CCMUX_TEXEL0, 0)        
                end   
            end)
            
        elseif sabers_table[obj_get_model_id_extended(o)] or bz_sabers_table[obj_get_model_id_extended(o)] then    
            local mat = 0
            local mat2 = 0
    
            local dl = cast_graph_node(o.header.gfx.sharedChild.children)
            gfx_parse(dl.displayList, function(cmd, op)
                if op == G_SETPRIMCOLOR and bz_sabers_table[obj_get_model_id_extended(o)] then
                    local r = 184 + mat * 50
                    local g = 130 + mat * 50
                    local b = 245 + mat * 10
                    gfx_set_command(cmd, "gsDPSetPrimColor", 255, 255, r, g, b, 255)
                    mat = mat + 1
                elseif op == G_SETCOMBINE then
                    if not (obj_get_model_id_extended(o) == E_model_ryuenjin1 or obj_get_model_id_extended(o) == E_model_ryuenjin2) then
                        if mat2 < 2 then
                            gfx_set_combine_lerp(cmd, 0, 0, 0, G_CCMUX_PRIMITIVE, 0, 0, 0, G_CCMUX_ENVIRONMENT, 0, 0, 0, G_ACMUX_PRIMITIVE, 0, 0, 0, G_ACMUX_ENVIRONMENT)
                        else
                            gfx_set_combine_lerp(cmd, 0, 0, 0, G_CCMUX_1, 0, 0, 0, G_CCMUX_ENVIRONMENT, 0, 0, 0, G_ACMUX_1, 0, 0, 0, G_ACMUX_ENVIRONMENT)
                        end
                    else
                        if (mat2 == 5 and obj_get_model_id_extended(o) == E_model_ryuenjin2) or (mat2 == 4 and obj_get_model_id_extended(o) == E_model_ryuenjin1) then
                            gfx_set_combine_lerp(cmd, 0, 0, 0, G_CCMUX_1, 0, 0, 0, G_CCMUX_ENVIRONMENT, 0, 0, 0, G_ACMUX_1, 0, 0, 0, G_ACMUX_ENVIRONMENT)
                        else
                            gfx_set_combine_lerp(cmd, 0, 0, 0, G_CCMUX_PRIMITIVE, 0, 0, 0, G_CCMUX_ENVIRONMENT, 0, 0, 0, G_ACMUX_PRIMITIVE, 0, 0, 0, G_ACMUX_ENVIRONMENT)
                        end
                    end
                    mat2 = mat2 + 1
                end   
            end)  
    
            o.header.gfx.pos.x = o.oPosX + sins(o.oMoveAngleYaw) * 17
            o.header.gfx.pos.z = o.oPosZ + coss(o.oMoveAngleYaw) * 17
            if o.oSaberIndex == HITBOX_MELEE_SHIPPUGA then
                o.header.gfx.angle.y = o.header.gfx.angle.y - 8000
                o.header.gfx.angle.x = o.header.gfx.angle.x + 4000
                o.header.gfx.pos.y = o.header.gfx.pos.y + 2
                o.header.gfx.pos.x = o.header.gfx.pos.x + sins(o.header.gfx.angle.y - 0x4000) * 10
                o.header.gfx.pos.z = o.header.gfx.pos.z + coss(o.header.gfx.angle.y - 0x4000) * 10
            end
        end
    end
end)
