function set_model(o, model)
    if not _G.charSelectExists and obj_has_behavior_id(o, id_bhvMario) ~= 0 then
        local i = network_local_index_from_global(o.globalPlayerIndex)
        local s = gPlayerSyncTable[i]
        if s.modelId ~= nil and s.character ~= 'none' and obj_has_model_extended(o, s.modelId) == 0 then
            obj_set_model_extended(o, s.modelId)
        end
        return
    end
end

hook_event(HOOK_OBJECT_SET_MODEL, set_model)

local NO_OFFSET_ACTIONS = {
    [ACT_GROUND_POUND] = true,
    [ACT_CROUCHING] = true,
    [ACT_START_CRAWLING] = true,
    [ACT_CRAWLING] = true,
    [ACT_RIDING_SHELL_GROUND] = true,
    [ACT_RIDING_SHELL_JUMP] = true,
    [ACT_RIDING_SHELL_FALL] = true,
    [ACT_STOP_CRAWLING] = true,
    [ACT_QUICKSAND_DEATH] = true,
    [ACT_GRABBED] = true,
}

function render_model(o)
    if o ~= nil and obj_has_behavior_id(o, id_bhvMario) ~= 0 then
        local i = network_local_index_from_global(o.globalPlayerIndex)
        local s = gPlayerSyncTable[i]
        local mmx = gMmxStates[i]
        if s.character ~= 'none' then
            local m = gMarioStates[i]
            if (m.marioBodyState.capState == MARIO_HAS_DEFAULT_CAP_OFF) then
                m.marioBodyState.capState = MARIO_HAS_DEFAULT_CAP_ON
            end
            local offset = MODEL_Y_OFFSET
            if s.character == 'zero' then
                offset = MODEL_Y_OFFSET_ZERO
            end
            
            if (not NO_OFFSET_ACTIONS[m.action]) then
                local ledge_shippuga_offset = 0
                if (m.action == ACT_SHIPPUGA and mmx.zero_ledge_shippuga == 1) then
                    ledge_shippuga_offset = -20
                end
                o.header.gfx.pos.y = m.pos.y + offset + ledge_shippuga_offset - m.quicksandDepth
            elseif (m.action == ACT_CROUCHING) then
                o.header.gfx.pos.y = m.pos.y + offset - 10 - m.quicksandDepth
            elseif m.action & ACT_FLAG_RIDING_SHELL ~= 0 then
                o.header.gfx.pos.y = m.pos.y + offset * 2 - m.quicksandDepth
            end
        end
    end
end

hook_event(HOOK_ON_OBJECT_RENDER, render_model)