local spawn_charge, spawn_napalm, network_player_from_global_index, spawn_non_sync_object = 
spawn_charge, spawn_napalm, network_player_from_global_index, spawn_non_sync_object

SOUND_X_CHARGE_BEGIN_IDX = 1
SOUND_X_CHARGE_LOOP_IDX = 2
SOUND_X_CHARGE_MAX_BEGIN_IDX = 3
SOUND_X_CHARGE_MAX_LOOP_IDX = 4
SOUND_X_GIGA_CHARGE_HOLD_IDX = 5

local packet_types_funcs = {
    -- Sounds
    ['sound'] = function(m, table)
        local soundtable = {
            [SOUND_X_CHARGE_BEGIN_IDX] = SOUND_X_CHARGE_BEGIN,
            [SOUND_X_CHARGE_LOOP_IDX] = SOUND_X_CHARGE_LOOP,
            [SOUND_X_CHARGE_MAX_BEGIN_IDX] = SOUND_X_CHARGE_MAX_BEGIN,
            [SOUND_X_CHARGE_MAX_LOOP_IDX] = SOUND_X_CHARGE_MAX_LOOP,
            [SOUND_X_GIGA_CHARGE_HOLD_IDX] = SOUND_X_GIGA_CHARGE_HOLD,
            [SOUND_X_SHOT1_IDX] = SOUND_X_SHOT1,
            [SOUND_X_SHOT2_IDX] = SOUND_X_SHOT2,
            [SOUND_X_SHOT3_IDX] = SOUND_X_SHOT3,
            [SOUND_X_SHOT_MAX_IDX] = SOUND_X_SHOT_MAX,
            [SOUND_VILE_SHOT_IDX] = SOUND_VILE_SHOT,
            [SOUND_VILE_CANNON_IDX] = SOUND_VILE_CANNON
        }
        mmx_play_sound(soundtable[table.sound_idx], m.pos, table.intensity)
    end,
    -- Effects
    ['charge'] = function(m, table)
        spawn_charge(m, table.chargeLevel)
    end,
    -- Weapons
    ['saber'] = function(m, table)
        spawn_non_sync_object(id_bhvSaber, E_MODEL_NONE, m.pos.x, m.pos.y, m.pos.z, function(o)
            o.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
            o.parentObj = m.marioObj
            o.oSaberIndex = table.saber_idx
            o.oHitboxGlobalIndex = table.id
        end)
    end,
    ['raikousen'] = function(m, table)
        spawn_non_sync_object(id_bhvRaikousenLightning, E_MODEL_NONE, m.pos.x, m.pos.y + 80, m.pos.z, function(o)
            o.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
            o.oHitboxGlobalIndex = table.id
        end)
    end,
    ['napalm'] = function(m, table)
        local grounded = false
        if table.grounded == 1 then
            grounded = true
        end
        spawn_napalm(m, grounded, table.id)
    end,
    ['gaea_gigaattack'] = function(m, table)
        spawn_gaea_gigaattack(m, table.id)
    end,
    ['shot'] = function(m, table)
        spawn_non_sync_object(id_bhvShot, E_MODEL_NONE, table.posX, table.posY, table.posZ, function(o)
            o.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
            o.oMoveAngleYaw = table.oMoveAngleYaw
            o.oShotType = table.oShotType
            o.oHitboxType = table.oHitboxType
            o.oHitboxDamage = table.oHitboxDamage
            o.oShotInitOffset = table.oShotInitOffset
            o.oShotInitRotPhase = table.oShotInitRotPhase
            o.oHitboxGlobalIndex = table.oHitboxGlobalIndex
        end)
    end,
    ['hitbox_id_sync'] = function(m, table)
        local mmx = gMmxStates[m.playerIndex]
        if table.remove == 1 then
            mmx.active_hitboxes[table.id] = nil
        else
            mmx.active_hitboxes[table.id] = {}
        end
    end,
}

local on_receive_spawn_data = function(table)
    local np = network_player_from_global_index(table.m)
    local m = gMarioStates[np.localIndex]
    if (active_player(m)) then
        packet_types_funcs[table.type](m, table)
    end
end

hook_event(HOOK_ON_PACKET_RECEIVE, on_receive_spawn_data)