-- name: \\#5B83B5\\Mega Man \\#EFC600\\X \\#AAAAAA\\v1.2.9\\#FFFFFF\\
-- description: Mega Man X v1.2.9
-- category: moveset

-----------------------------------------------------------------
----- LOCALIZED FUNCTIONS ---------------------------------------
-----------------------------------------------------------------
local set_mario_y_vel_based_on_fspeed, mmx_play_sound, set_mario_action, vile_meter_render, gaea_meter_render, render_hud_mario_lives,
mmx_play_sound, mmx_set_prev_faceAngle = 
set_mario_y_vel_based_on_fspeed, mmx_play_sound, set_mario_action, vile_meter_render, gaea_meter_render, render_hud_mario_lives,
mmx_play_sound, mmx_set_prev_faceAngle

local defaultFixCollisionBugs = gLevelValues.fixCollisionBugs
local defaultFixCollisionBugsRoundedCorners = gLevelValues.fixCollisionBugsRoundedCorners
local defaultFixCollisionBugsPickBestWall = gLevelValues.fixCollisionBugsPickBestWall
local defaultFixCollisionBugsGroundPoundBonks = gLevelValues.fixCollisionBugsGroundPoundBonks
local pauseExited = false

x_hud_icon = get_texture_info("mmx_x_hud")
x_lightarmor_hud_icon = get_texture_info("mmx_x_lightarmor_hud")
x_gigaarmor_hud_icon = get_texture_info("mmx_x_gigaarmor_hud")
x_gaeaarmor_hud_icon = get_texture_info("mmx_x_gaeaarmor_hud")
vile_hud_icon = get_texture_info("mmx_vile_hud")
zero_hud_icon = get_texture_info("mmx_zero_hud_big")
zero_bz_hud_icon = get_texture_info("mmx_zero_bz_hud_big")
alia_hud_icon = get_texture_info("mmx_alia_hud")

-- Character Select Support
if _G.charSelectExists then


    local X_DESC = {
        "-B: X-Buster",
        "-Z: Dash",
        "-Y (Ground): Punch",
        "-Y (Air): Ground pound",
        "",
        "Current Armor: None"
    }
    local ZERO_DESC = {
        "-B (Ground): Triple Z-Saber combo",
        "-B (Air): Air slash",
        "-Z: Dash",
        "-Y (Ground): Punch",
        "-Dash (Ground) + Y: Shippuga",
        "-Y (Air): Kuuenzan",
        "-X (Ground): Ryuenjin",
        "-Dash (Ground) + X: Raikousen",
        "-X (Air): Hyouretsuzan",
        "-Dash (Air) + X: Sentsuizan"
    }
    local VILE_DESC = {
        "-B: Vulcan (Cherry Blast)",
        "-Z (Ground): Dash Attack",
        "-Z (Air): Ground pound",
        "-Y: Napalm (Bumpity Boom)",
        "-X: Cannon (Front Runner)"
    }
    local ALIA_DESC = {
        "-B: Alia Buster",
        "-Z: Dash",
        "-Y (Ground): Punch",
        "-Y (Air): Ground pound",
    }

    local X_LIGHT_DESC = {
        "Type: Armor",
        "(+) Spiral Crush Buster Shot",
    }

    local X_GIGA_DESC = {
        "Type: Armor",
        "(+) Double Shot",
    }

    local X_GAEA_DESC = {
        "Type: Armor",
        "(+) Geae Shot",
        "(+) Wall cling",
        "(+) Giga Attack",
        "(+) Less damage from lava",
        "(-) Slower dash speed"
    }

    local X_CM_DESC = {
        "Type: Alt",
        "Same as default X"
    }

    local ZERO_BLACKZERO_DESC = {
        "Type: Alt",
        "Same as default Zero"
    }

    -- Character Initialize
    X_CS = _G.charSelect.character_add("X", X_DESC, "ganewatch", {r = 39, g = 95, b = 216}, E_model_mmx_x, CT_MARIO, x_hud_icon)
    ZERO_CS = _G.charSelect.character_add("Zero", ZERO_DESC, "ganewatch", {r = 39, g = 95, b = 216}, E_model_mmx_zero, CT_MARIO, zero_hud_icon)
    VILE_CS = _G.charSelect.character_add("Vile", VILE_DESC, "ganewatch", {r = 39, g = 95, b = 216}, E_model_mmx_vile, CT_MARIO, vile_hud_icon)
    ALIA_CS = _G.charSelect.character_add("Alia", ALIA_DESC, "ganewatch", {r = 39, g = 95, b = 216}, E_model_mmx_alia, CT_MARIO, alia_hud_icon)


    -- Add Voices and Palette
    _G.charSelect.character_add_voice(E_model_mmx_x, X_CUSTOM_VOICETABLE)
    _G.charSelect.character_add_voice(E_model_mmx_x_lightarmor, X_CUSTOM_VOICETABLE)
    _G.charSelect.character_add_voice(E_model_mmx_x_gigaarmor, X_CUSTOM_VOICETABLE)
    _G.charSelect.character_add_voice(E_model_mmx_x_gaeaarmor, X_CUSTOM_VOICETABLE)
    _G.charSelect.character_add_voice(E_model_mmx_x_cm, X_CUSTOM_VOICETABLE)
    _G.charSelect.character_add_voice(E_model_mmx_x_cm_noanim, X_CUSTOM_VOICETABLE)

    _G.charSelect.character_add_voice(E_model_mmx_zero, ZERO_CUSTOM_VOICETABLE)
    _G.charSelect.character_add_voice(E_model_mmx_zero_bz, ZERO_CUSTOM_VOICETABLE)

    _G.charSelect.character_add_voice(E_model_mmx_vile, VILE_CUSTOM_VOICETABLE)
    _G.charSelect.character_add_voice(E_model_mmx_vile_defaulthands, VILE_CUSTOM_VOICETABLE)
    _G.charSelect.character_add_voice(E_model_mmx_vile_knee, VILE_CUSTOM_VOICETABLE)
    _G.charSelect.character_add_voice(E_model_mmx_vile_cannon, VILE_CUSTOM_VOICETABLE)

    _G.charSelect.character_add_voice(E_model_mmx_alia, ALIA_CUSTOM_VOICETABLE)


    _G.charSelect.character_add_palette_preset(E_model_mmx_x, x_defaultcolors)
    _G.charSelect.character_add_palette_preset(E_model_mmx_x_lightarmor, x_lightarmor_defaultcolors)
    _G.charSelect.character_add_palette_preset(E_model_mmx_x_gigaarmor, x_gigaarmor_defaultcolors)
    _G.charSelect.character_add_palette_preset(E_model_mmx_x_gaeaarmor, x_gaeaarmor_defaultcolors)
    _G.charSelect.character_add_palette_preset(E_model_mmx_x_cm, x_cm_defaultcolors)
    _G.charSelect.character_add_palette_preset(E_model_mmx_x_cm_noanim, x_cm_defaultcolors)

    _G.charSelect.character_add_palette_preset(E_model_mmx_zero, zero_defaultcolors)
    _G.charSelect.character_add_palette_preset(E_model_mmx_zero_bz, black_zero_defaultcolors)

    _G.charSelect.character_add_palette_preset(E_model_mmx_vile, vile_defaultcolors)
    _G.charSelect.character_add_palette_preset(E_model_mmx_vile_defaulthands, vile_defaultcolors)
    _G.charSelect.character_add_palette_preset(E_model_mmx_vile_knee, vile_defaultcolors)
    _G.charSelect.character_add_palette_preset(E_model_mmx_vile_cannon, vile_defaultcolors)

    _G.charSelect.character_add_palette_preset(E_model_mmx_alia, alia_defaultcolors)

    X_LIGHTARMOR_CS = _G.charSelect.character_add_costume(X_CS, 'X - First Armor', X_LIGHT_DESC, 'ganewatch', nil, E_model_mmx_x_lightarmor, CT_MARIO, x_lightarmor_hud_icon)
    X_GIGAARMOR_CS = _G.charSelect.character_add_costume(X_CS, 'X - Second Armor', X_GIGA_DESC, 'ganewatch', nil, E_model_mmx_x_gigaarmor, CT_MARIO, x_gigaarmor_hud_icon)
    X_GAEAARMOR_CS = _G.charSelect.character_add_costume(X_CS, 'X - Gaea Armor', X_GAEA_DESC, 'ganewatch', nil, E_model_mmx_x_gaeaarmor, CT_MARIO, x_gaeaarmor_hud_icon)
    X_COMMANDMISSION_CS = _G.charSelect.character_add_costume(X_CS, 'X - Command Mission', X_CM_DESC, 'ganewatch', nil, E_model_mmx_x_cm)

    ZERO_BLACKZERO_CS = _G.charSelect.character_add_costume(ZERO_CS, 'Black Zero', ZERO_BLACKZERO_DESC, 'ganewatch', nil, E_model_mmx_zero_bz, CT_MARIO, zero_bz_hud_icon)

    -- Update Voicelines
    local character_get_voice, update_sound = _G.charSelect.character_get_voice, _G.charSelect.voice.sound
    local function character_sounds(m, sound)
        local v = _G.charSelect.character_get_voice(m)
        if v == X_CUSTOM_VOICETABLE or v == ZERO_CUSTOM_VOICETABLE or v == VILE_CUSTOM_VOICETABLE
        or v == ALIA_CUSTOM_VOICETABLE
        then
            return update_sound(m, sound)
        end
    end

    hook_event(HOOK_CHARACTER_SOUND, character_sounds)
end

local function character_select_update()
    local s = gPlayerSyncTable[0]
    if X_CS == _G.charSelect.character_get_current_number() then
        s.character = 'x'
        s.x_is_alia = 0
        if _G.charSelect.character_get_current_costume() == X_COMMANDMISSION_CS then
            s.x_armor = 0
            s.x_cm = 1
        elseif _G.charSelect.character_get_current_costume() == X_LIGHTARMOR_CS then
            s.x_cm = 0
            s.x_armor = 1
        elseif _G.charSelect.character_get_current_costume() == X_GIGAARMOR_CS then
            s.x_cm = 0
            s.x_armor = 2
        elseif _G.charSelect.character_get_current_costume() == X_GAEAARMOR_CS then
            s.x_cm = 0
            s.x_armor = 4
        else
            s.x_cm = 0
            s.x_armor = 0
        end
    elseif ZERO_CS == _G.charSelect.character_get_current_number() then
        s.character = 'zero'
        if _G.charSelect.character_get_current_costume() == ZERO_BLACKZERO_CS then
            s.zero_alt = 1
        else
            s.zero_alt = 0
        end
    elseif VILE_CS == _G.charSelect.character_get_current_number() then
        s.character = 'vile'
    elseif ALIA_CS == _G.charSelect.character_get_current_number() then
        s.character = 'x'
        s.x_cm = 0
        s.x_is_alia = 1
        s.x_armor = 0
    else
        s.character = 'none'
    end
end

local ALLOWED_FIX_COLLISION_BUGS_ACTIONS = {
    [ACT_WALKING_CUSTOM] = true,
    [ACT_FREEFALL_CUSTOM] = true,
    [ACT_WATER_JUMP] = true,
    [ACT_JUMP_CUSTOM] = true,
    [ACT_ZERO_DOUBLE_JUMP] = true,
    [ACT_WALL_KICK_CUSTOM] = true,
    [ACT_WALL_SLIDE] = true,
    [ACT_AIR_HIT_WALL_CUSTOM] = true,
    [ACT_DASH] = true,
    [ACT_AIR_DASH] = true,
    [ACT_VILE_DASH] = true,
    [ACT_GROUND_POUND] = true,
}

function mario_update(m)
    local s = gPlayerSyncTable[m.playerIndex]
    local mmx = gMmxStates[m.playerIndex]

    if _G.charSelectExists and m.playerIndex == 0 then
        character_select_update()
    end

    if (s.character == 'x') then
        if m.playerIndex == 0 then
            x_update_local(m)
        end
        if active_player(m) then
            x_update_all(m)
        end
    elseif (s.character == 'zero') then
        if m.playerIndex == 0 then
            zero_update_local(m)
        end
        if active_player(m) then
            zero_update_all(m)
        end
    elseif (s.character == 'vile') then
        if m.playerIndex == 0 then
            vile_update_local(m)
        end
        if active_player(m) then
            vile_update_all(m)
        end
    end

    if m.playerIndex == 0 then
        if (s.character ~= 'x' or s.x_armor ~= 2) then
            mmx.x_right_hand_shot = false
            s.x_doubleshot = 0
        end
    end

    if (s.palette_reset_signal) then
        network_player_reset_override_palette(gNetworkPlayers[m.playerIndex])
        if (m.playerIndex == 0) then
            s.palette_reset_signal = false
        end
    end

    if (s.character ~= 'none') then
        if m.playerIndex == 0 then
            if ALLOWED_FIX_COLLISION_BUGS_ACTIONS[m.action] and pauseExited == false then
                gLevelValues.fixCollisionBugs = 1
                gLevelValues.fixCollisionBugsRoundedCorners = 0
                gLevelValues.fixCollisionBugsPickBestWall = 1
                gLevelValues.fixCollisionBugsGroundPoundBonks = 1
                if mmx.can_restore_glevelvalue == 0 then
                    mmx.can_restore_glevelvalue = 1
                end
            elseif mmx.can_restore_glevelvalue == 1 then
                gLevelValues.fixCollisionBugs = defaultFixCollisionBugs
                gLevelValues.fixCollisionBugsRoundedCorners = defaultFixCollisionBugsRoundedCorners
                gLevelValues.fixCollisionBugsPickBestWall = defaultFixCollisionBugsPickBestWall
                gLevelValues.fixCollisionBugsGroundPoundBonks = defaultFixCollisionBugsGroundPoundBonks
                mmx.can_restore_glevelvalue = 0
            end
        end
        mmx_set_prev_faceAngle(m)
        mmx.dPrevPos = {
            x = m.pos.x - mmx.prevPos.x,
            y = m.pos.y - mmx.prevPos.y,
            z = m.pos.z - mmx.prevPos.z
        }
        mmx.prevPos = { x = m.pos.x, y = m.pos.y, z = m.pos.z}

        -- This momentarily swaps to the vanilla walking action upon interacting with doors
        -- Because the code that handles door interaction is hardwired to ACT_WALKING
        if (m.marioObj.collidedObjInteractTypes & (INTERACT_WARP_DOOR | INTERACT_DOOR | INTERACT_KOOPA_SHELL) ~= 0 
        and m.action == ACT_WALKING_CUSTOM) then
            if (m.playerIndex == 0) then
                s.execute_walking = true
            end
            set_mario_action(m, ACT_WALKING, 0)
        elseif m.action == ACT_WALKING then
            if (m.playerIndex == 0) then
                s.execute_walking = false
            end
            set_mario_action(m, ACT_WALKING, 0)
        end
    elseif mmx.can_restore_glevelvalue == 1 then
        if m.playerIndex == 0 then
            gLevelValues.fixCollisionBugs = defaultFixCollisionBugs
            gLevelValues.fixCollisionBugsRoundedCorners = defaultFixCollisionBugsRoundedCorners
            gLevelValues.fixCollisionBugsPickBestWall = defaultFixCollisionBugsPickBestWall
            gLevelValues.fixCollisionBugsGroundPoundBonks = defaultFixCollisionBugsGroundPoundBonks
            mmx.can_restore_glevelvalue = 0
        end
    end
end

-------------------------------------
---- Before set action functions ----
-------------------------------------

-- ACT_DIVE
function before_act_dive(m, incomingAct)
    local mmx = gMmxStates[m.playerIndex]
    if (m.action & ACT_FLAG_AIR) == 0 then
        if (mmx.execute_punch) then
            return ACT_MOVE_PUNCHING
        end
    end
    mmx.smoothContinuityFlag = true
    return 1
end

-- ACT_CROUCH_SLIDE
function before_act_crouch_slide(m, incomingAct)
    if (m.playerIndex == 0) then
        m.marioObj.header.gfx.pos.y = m.pos.y
    end
    return 1
end

-- ACT_FREEFALL_LAND_STOP
-- ACT_FREEFALL_LAND
-- ACT_JUMP_LAND
function before_general_act_land(m, incomingAct)
    local s = gPlayerSyncTable[m.playerIndex]
    local mmx = gMmxStates[m.playerIndex]
    if (m.playerIndex == 0) then
        if s.character == 'x' then
            mmx_play_sound(SOUND_X_LAND, m.pos, 0.6)
        elseif s.character == 'zero' then
            mmx_play_sound(SOUND_ZERO_LAND, m.pos, 0.4)
        elseif s.character == 'vile' then
            mmx_play_sound(SOUND_VILE_STEP, m.pos, 0.35)
        end
    end
    mmx.land_timer = 0
    return ACT_FREEFALL_LAND_STOP
end

-- ACT_JUMP_KICK
-- ACT_LEDGE_GRAB
-- ACT_LEDGE_CLIMB_DOWN
-- ACT_LEDGE_CLIMB_FAST
function before_several_act_unused_smooth(m, incomingAct)
    local mmx = gMmxStates[m.playerIndex]
    mmx.smoothContinuityFlag = true
    if (m.action == ACT_HOLD_JUMP or m.action == ACT_HOLD_FREEFALL) then
        return ACT_FREEFALL_CUSTOM
    end
    return 1
end 

function before_several_act_jump_kick(m, incomingAct)
    return ACT_PUNCHING
end 

-- ACT_WALKING
-- ACT_FINISH_TURNING_AROUND
function before_act_walking(m, incomingAct)
    local s = gPlayerSyncTable[m.playerIndex]
    if (incomingAct == ACT_WALKING) then
        if (s.execute_walking) then
            return incomingAct
        end
        local floorClass = mario_get_floor_class(m)
        if (floorClass ~= SURFACE_CLASS_VERY_SLIPPERY) then
            local mag = math.min(m.intendedMag, 8)
            if (0.0 <= m.forwardVel and m.forwardVel < mag) then
                m.forwardVel = mag
            end
        end
    end
    return ACT_WALKING_CUSTOM
end

-- ACT_MOVE_PUNCHING
function before_act_move_punching(m, incomingAct)
    local mmx = gMmxStates[m.playerIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    if (mmx.execute_punch) then
        return incomingAct
    end
    mmx.smoothContinuityFlag = true
    return 1
end

-- ACT_PUNCHING
function before_act_punching(m, incomingAct)
    local mmx = gMmxStates[m.playerIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    if (mmx.execute_punch) then
        return incomingAct
    end
    -- Just this line is enough, we don't need to smooth the continuity because the character is stationary
    m.marioObj.header.gfx.pos.y = m.pos.y
    return 1
end

-- ACT_FREEFALL
function before_act_freefall(m, incomingAct)
    return ACT_FREEFALL_CUSTOM
end

-- ACT_JUMP
-- ACT_STEEP_JUMP
-- ACT_DOUBLE_JUMP
-- ACT_BACKFLIP
-- ACT_SIDE_FLIP
function before_act_general_jump(m, incomingAct)
    local s = gPlayerSyncTable[m.playerIndex]
    -- Offset the jump so the player model doesn't slightly clip into the ground right after jumps
    m.pos.y = m.pos.y + MODEL_Y_OFFSET
    -- This code was found in the set_mario_action for ACT_JUMP
    m.marioObj.header.gfx.animInfo.animID = -1;
    set_mario_y_vel_based_on_fspeed(m, 43.0, 0.25);
    m.forwardVel = m.forwardVel * 0.8;
    if (s.character == 'x') then
        if s.x_shooting > 0 and m.playerIndex == 0 then
            s.x_shooting = 0
        end
        mmx_play_sound(SOUND_X_JUMP, m.pos, 0.3)
    elseif (s.character == 'vile') then
        mmx_play_sound(SOUND_VILE_JUMP, m.pos, 0.4)
    elseif (s.character == 'zero') then
        mmx_play_sound(SOUND_ZERO_JUMP, m.pos, 0.6)
    end
    return ACT_JUMP_CUSTOM
end

-- ACT_WATER_JUMP
function before_act_water_jump(m, incomingAct)
    if (m.playerIndex == 0) then
        set_camera_mode(m.area.camera, m.area.camera.defMode, 1)
    end
    return incomingAct
end

-- ACT_WALL_KICK_AIR
-- ACT_TOP_OF_POLE_JUMP
function before_act_pole_jump(m, incomingAct)
    -- Offset the jump so the player model doesn't slightly clip into the ground right after jumps
    m.pos.y = m.pos.y + MODEL_Y_OFFSET
    -- This code was found in the set_mario_action for ACT_JUMP
    m.marioObj.header.gfx.animInfo.animID = -1;
    set_mario_y_vel_based_on_fspeed(m, 65.0, 0.25);
    m.forwardVel = m.forwardVel * 0.8;
    return ACT_JUMP_CUSTOM
end

-- ACT_IDLE
function before_act_idle(m, incomingAct)
    set_anim_to_frame(m, 1)
    return incomingAct
end

-- ACT_AIR_HIT_WALL
function before_act_air_hit_wall(m, incomingAct)
    return ACT_AIR_HIT_WALL_CUSTOM
end

-- ACT_GROUND_POUND
function before_act_ground_pound(m, incomingAct)
    local s = gPlayerSyncTable[m.playerIndex]
    if (s.character == 'zero') then
        return ACT_HYOURETSUZAN
    else
        return incomingAct
    end
end

-- ACT_BACKWARD_GROUND_KB
function before_act_backward_ground_kb(m, incomingAct)
    if m.action == ACT_DECELERATING or m.action == ACT_BRAKING or m.action == ACT_BRAKING_STOP then
        return ACT_IDLE
    end
    return incomingAct
end

local convert_actions = {
    [ACT_WALKING] = before_act_walking,
    [ACT_DIVE] = before_act_dive,
    [ACT_CROUCH_SLIDE] = before_act_crouch_slide,
    [ACT_FREEFALL_LAND_STOP] = before_general_act_land,
    [ACT_FREEFALL_LAND] = before_general_act_land,
    [ACT_JUMP_LAND] = before_general_act_land,
    [ACT_JUMP_KICK] = before_several_act_jump_kick,
    [ACT_LEDGE_GRAB] = before_several_act_unused_smooth,
    [ACT_LEDGE_CLIMB_DOWN] = before_several_act_unused_smooth,
    [ACT_LEDGE_CLIMB_FAST] = before_several_act_unused_smooth,
    [ACT_FINISH_TURNING_AROUND] = before_act_walking,
    [ACT_MOVE_PUNCHING] = before_act_move_punching,
    [ACT_PUNCHING] = before_act_punching,
    [ACT_FREEFALL] = before_act_freefall,
    [ACT_JUMP] = before_act_general_jump,
    [ACT_WALL_KICK_AIR] = before_act_pole_jump,
    [ACT_TOP_OF_POLE_JUMP] = before_act_pole_jump,
    [ACT_STEEP_JUMP] = before_act_general_jump,
    [ACT_DOUBLE_JUMP] = before_act_general_jump,
    [ACT_BACKFLIP] = before_act_general_jump,
    [ACT_SIDE_FLIP] = before_act_general_jump,
    [ACT_WATER_JUMP] = before_act_water_jump,
    [ACT_IDLE] = before_act_idle,
    [ACT_AIR_HIT_WALL] = before_act_air_hit_wall,
    [ACT_GROUND_POUND] = before_act_ground_pound,
    [ACT_BACKWARD_GROUND_KB] = before_act_backward_ground_kb,
}

local poleActions = {
    [ACT_GRAB_POLE_FAST] = true,
    [ACT_GRAB_POLE_SLOW] = true,
    [ACT_HOLDING_POLE] = true,
    [ACT_CLIMBING_POLE] = true,
    [ACT_TOP_OF_POLE] = true,
    [ACT_TOP_OF_POLE_JUMP] = true,
    [ACT_TOP_OF_POLE_TRANSITION] = true,
}

local before_set_mario_action = function(m, incomingAct)
    local s = gPlayerSyncTable[m.playerIndex]
    local mmx = gMmxStates[m.playerIndex]
    if active_player(m) and s.character ~= 'none' then
        if not poleActions[incomingAct] then
            m.marioObj.oMarioWalkingPitch = 0
        end
        if (m.action == ACT_WALL_SLIDE) then
            m.faceAngle.y = m.faceAngle.y + 0x8000
            if (m.input & INPUT_NONZERO_ANALOG) == 0 and incomingAct == ACT_FREEFALL_CUSTOM then
                m.intendedYaw = m.faceAngle.y
            elseif incomingAct ~= ACT_WALL_KICK_CUSTOM then
                m.faceAngle.y = m.intendedYaw
            end
            mmx.wall_prev = ''
        end
        if (m.action) == ACT_RAIKOUSEN and incomingAct == ACT_IDLE then
            m.marioObj.oIntangibleTimer = 0
            m.marioObj.header.gfx.node.flags = m.marioObj.header.gfx.node.flags &~ GRAPH_RENDER_INVISIBLE
        end
        if convert_actions[incomingAct] then
            return convert_actions[incomingAct](m, incomingAct)
        end
        return incomingAct
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)
hook_event(HOOK_BEFORE_SET_MARIO_ACTION, before_set_mario_action)


hook_event(HOOK_ON_HUD_RENDER_BEHIND, function()
    local m = gMarioStates[0]
    local s = gPlayerSyncTable[m.playerIndex]
    if (m.action ~= ACT_END_PEACH_CUTSCENE and m.action ~= ACT_END_WAVING_CUTSCENE and (m.action ~= ACT_INTRO_CUTSCENE or introTimer >= 1195)) then
        djui_hud_set_resolution(RESOLUTION_N64)
        djui_hud_set_font(FONT_HUD)
        djui_hud_set_color(255, 255, 255, 255)
        if (s.character == 'vile') then
            vile_meter_render()
        elseif (s.character == 'x' and s.x_armor == 4) then
            gaea_meter_render()
        end
        if _G.charSelectExists then
            return
        end
        if (s.character ~= 'none') then
            render_hud_mario_lives()
        else    
            hud_set_value(HUD_DISPLAY_FLAGS, hud_get_value(HUD_DISPLAY_FLAGS) | HUD_DISPLAY_FLAG_LIVES)
        end
    end
end)

hook_event(HOOK_ON_WARP, function()
    --djui_chat_message_create(tostring(gLevelValues.fixCollisionBugs))
    pauseExited = false
    defaultFixCollisionBugs = gLevelValues.fixCollisionBugs
    defaultFixCollisionBugsRoundedCorners = gLevelValues.fixCollisionBugsRoundedCorners
    defaultFixCollisionBugsPickBestWall = gLevelValues.fixCollisionBugsPickBestWall
    defaultFixCollisionBugsGroundPoundBonks = gLevelValues.fixCollisionBugsGroundPoundBonks
    local s = gPlayerSyncTable[0]
    local mmx = gMmxStates[0]
    mmx.active_hitboxes = {}
end)

hook_event(HOOK_ON_PAUSE_EXIT, function()
    pauseExited = true
end)

GRAB_ACTIONS = {
    [ACT_WALKING_CUSTOM] = true,
    [ACT_IDLE] = true,
}

local on_interact = function(m, o, intType)
    local s = gPlayerSyncTable[m.playerIndex]
    if (s.character == 'none') then
        return
    end
    local mmx = gMmxStates[m.playerIndex]
    if (m.action == ACT_SHIPPUGA or (GRAB_ACTIONS[m.action] and mmx.b_pressed > 0)) then
        if (intType & (INTERACT_GRABBABLE) ~= 0) and o.oInteractionSubtype & (INT_SUBTYPE_NOT_GRABBABLE) == 0 then
            m.interactObj = o
            m.input = m.input | INPUT_INTERACT_OBJ_GRABBABLE
            if o.oSyncID ~= 0 then
                network_send_object(o, true)
            end
        end
    end
end

hook_event(HOOK_ALLOW_INTERACT, on_interact)